
[LBS,UBS,lambdas]   = test_04_06_15(lambda_comp,lambda_coll,lambda_home,pp_comp,pp_coll,pp_home,comp_prem,coll_prem,home_prem,deduc_list_comp,deduc_list_coll,deduc_list_home,...
        comp_deduc,coll_deduc,home_deduc,RR_Mins_Monotone,LOWER_BAR,UPPER_BAR,Num_Obs);

square_distance  = 0;

N_temp       = sum(monotone==1);
BtS          = 200;
candidate    = [(.08)  (.75) 0  0   0   0];
lower        = [(.0)  (.1) -125 -125  -125 -125];

upper        = [(.2)  (2.5) 150  150 150  150];

pol_length   = length(candidate);
lambdas_temp = lambdas(monotone==1,:);
UBS_temp     = UBS(monotone==1,:);
LBS_temp     = LBS(monotone==1,:);

distance_to_mu=omega_distance_fast([0 1 0],lambdas_temp,UBS_temp,LBS_temp,square_distance,3,3,N_temp);
disp(distance_to_mu/N_temp/3*100)


[M_distance_out,MON_distance] = fmincon(@omega_distance_fast,candidate,[0 -1 -2*.16 -3*.16^2 -4*.16^3 -5*.16^4],0,[],[],lower,upper,[],optimset('TolFun',1e-8,'TolX',1e-8,'MaxFunEvals',5000,'algorithm','active-set','Display','off'),...
                                lambdas_temp,UBS_temp,LBS_temp,square_distance,pol_length,3,N_temp);
replace = 'true';
parfor ii=1:BtS
    disp(ii)
    rng(123456+ii*100)
    rand_draw = randsample(N_temp,N_temp,replace);
    ML_distance_out(ii,:) =fmincon(@omega_distance_fast,candidate,M_distance_out,0,[],[],lower,upper,[],optimset('TolFun',1e-8,'TolX',1e-8,'MaxFunEvals',5000,'algorithm','active-set','Display','off'),...
                                lambdas_temp(rand_draw,:),UBS_temp(rand_draw,:),LBS_temp(rand_draw,:),square_distance,pol_length,3,N_temp); %#ok<PFBNS>
end


disp('min distance Omega intersept and slope Omega')
disp((M_distance_out))
disp('stds for min distance Omega intersept and slope')
disp(std((ML_distance_out)))

disp('MON_distance')
disp(MON_distance/N_temp/3*100)

distance_to_mu=omega_distance_fast([0 1 0],lambdas_temp,UBS_temp,LBS_temp,square_distance,3,3,N_temp);
disp(distance_to_mu/N_temp/3*100)


mu_plot = 0:.001:2;

Min_Distance_Omega_M =      ( M_distance_out(1))+( M_distance_out(2))*mu_plot+( M_distance_out(3))*mu_plot.^2+( M_distance_out(4))*mu_plot.^3+( M_distance_out(5))*mu_plot.^4+( M_distance_out(6))*mu_plot.^5;

Min_Distance_Omega_ML =     repmat( ML_distance_out(:,1),1,length(mu_plot))+( ML_distance_out(:,2))*mu_plot+(ML_distance_out(:,3))*mu_plot.^2+( ML_distance_out(:,4))*mu_plot.^3+( ML_distance_out(:,5))*mu_plot.^4+( ML_distance_out(:,6))*mu_plot.^5;


%%


figure
plot(mu_plot,Min_Distance_Omega_M,'r','linewidth',2)
hold on
plot(mu_plot,quantile(Min_Distance_Omega_ML,0.025),'r-d','linewidth',.5,'markersize',1)

load pwl_outcome


plot(PWL_Points,PWL_Omega_Function,'b--','LineWidth',2)

plot(PWL_Points,PWL_Conf_Band_Low,'b-.','LineWidth',1)
plot(mu_plot,mu_plot,'k--','LineWidth',.5,'markersize',2)
plot(PWL_Points,PWL_Conf_Band_High,'b-.','LineWidth',1)
plot(mu_plot,quantile(Min_Distance_Omega_ML,0.975),'r-d','linewidth',.5,'markersize',1)

axis([0 .16 0 .31])

legend('Minimum distance \Omega','95 percent confidence band','BMOT maximum likelihood \Omega','BMOT 95 percent confidence band','45 degree line','location','northwest')
legend boxoff
xlabel('\mu')


print -depsc2 Figure_5



[~,distance_Vec_out_M]     = omega_distance_fast( M_distance_out,lambdas_temp,UBS_temp,LBS_temp,square_distance,pol_length,3,N_temp);

tolerance_vector            = 0:.0025:.025;
fraction_inside_3_M         = zeros(1,length(tolerance_vector));
fraction_inside_2_M         = zeros(1,length(tolerance_vector));
fraction_inside_1_M         = zeros(1,length(tolerance_vector));


for ii =1:length(tolerance_vector)
    tolerance_for_min_dist = tolerance_vector(ii);
    
    fraction_inside_3_M(ii)         = sum(sum((distance_Vec_out_M<1e-9+tolerance_for_min_dist),2)>2);
    fraction_inside_2_M(ii)         = sum(sum((distance_Vec_out_M<1e-9+tolerance_for_min_dist),2)>1);
    fraction_inside_1_M(ii)         = sum(sum((distance_Vec_out_M<1e-9+tolerance_for_min_dist),2)>0);
    
end


figure
plot(tolerance_vector,fraction_inside_3_M/(N_temp)*100,'b','LineWidth',4)
hold on
plot(tolerance_vector,fraction_inside_2_M/(N_temp)*100,'b--','LineWidth',3)
plot(tolerance_vector,fraction_inside_1_M/(N_temp)*100,'b-.','LineWidth',2)
ylabel('Percent of monotone households')
legend('All three choices','At least two choices', 'At least one choice','Location','SouthEast')
legend boxoff
axis([0 max(tolerance_vector) 0 100])
xlabel('Error tolerance')



print -depsc2 Figure_6




%%

N_temp       = sum(linear==1);

candidate = [(.08)  (.75)];
lower     = [(.01)  (.1) ];

upper     = [(.2)  5];

pol_length   = length(candidate);
lambdas_temp = lambdas(linear==1,:);
UBS_temp     = Omega_max_out;
LBS_temp     = Omega_min_out;


[L_distance_out,LIN_distance] = fmincon(@omega_distance_fast,candidate,[],[],[],[],lower,upper,[],optimset('TolFun',1e-8,'TolX',1e-8,'MaxFunEvals',5000,'algorithm','active-set','Display','off'),...
                                lambdas_temp,UBS_temp,LBS_temp,square_distance,pol_length,3,N_temp);
disp('min distance Omega intersept and slope Omega')
disp(L_distance_out)
disp('LIN_distance')
disp(LIN_distance/N_temp/3*100)


Min_Distance_Omega_L =      ( L_distance_out(1))+( L_distance_out(2))*mu_plot;




N_temp                = sum(quadratic==1);
candidate = [(.08)  (.75) 0];
lower     = [(.0)  (.1) -12];
upper     = [(.2)  (2.5)  0];

lambdas_temp          = lambdas(quadratic==1,:);
UBS_temp    =   QQ_Omega_max_out(quadratic==1,:);
LBS_temp    =   QQ_Omega_min_out(quadratic==1,:);
pol_length = length(candidate);
[Q_distance_out,QUAD_distance] = fmincon(@omega_distance_fast,candidate,[],[],[],[],lower,upper,[],optimset('TolFun',1e-8,'TolX',1e-8,'MaxFunEvals',5000,'algorithm','active-set','Display','off'),...
                                    lambdas_temp,UBS_temp,LBS_temp,square_distance,pol_length,3,N_temp);

disp('min distance Omega intersept and slope Omega')
disp((Q_distance_out))

disp('QUAD_distance')
disp(QUAD_distance/N_temp/3*100)



Min_Distance_Omega_Q =      ( Q_distance_out(1))+( Q_distance_out(2))*mu_plot+( Q_distance_out(3))*mu_plot.^2;



figure
plot(mu_plot,Min_Distance_Omega_M,'r','linewidth',2)
hold on

plot(mu_plot,Min_Distance_Omega_Q,'k','linewidth',2)
plot(mu_plot,Min_Distance_Omega_L,'g','linewidth',2)

load pwl_outcome


plot(PWL_Points,PWL_Omega_Function,'b--','LineWidth',2)

plot(PWL_Points,PWL_Conf_Band_Low,'b-.','LineWidth',1)
plot(mu_plot,mu_plot,'k--','LineWidth',.5,'markersize',2)
plot(PWL_Points,PWL_Conf_Band_High,'b-.','LineWidth',1)
axis([0 .16 0 .31])

legend('Minimum distance \Omega, fifth order','Minimum distance \Omega, second order', 'Minimum distance \Omega, first order','BMOT maximum likelihood \Omega','BMOT 95 percent confidence band','45 degree line','location','northwest')
legend boxoff
xlabel('\mu')


print -depsc2 Figure_A4


