
% % this file is designed to create our analysis for types

% The first distinction to be drawn is EUT vs P-distortions


MON_alone       =   MONOTONICITY(:,1);
KR_alone        =   KR(:,1);
GD_alone        =   GD(:,1);
UNIT_SLOPE_alone=   UNIT_SLOPE(:,1);
CARA_alone      =   cara;
EV_alone        =   mean(CARA(:,1));
var_EV_alone    =   EV_alone*(1-EV_alone)/Num_Obs;


% we now compute: the union, the intersection and set diff
Both_CARA_and_MON     =   (CARA_alone+MON_alone==2);
Either_CARA_or_MON    =   (CARA_alone+MON_alone>0);
MON_only              =   MON_alone-CARA_alone==1;
CARA_only             =   CARA_alone-MON_alone==1;


% disp('Monotonicity CARA Both Either')
% disp(sum([MON_alone CARA_alone Both_CARA_and_MON Either_CARA_or_MON])/length(MON_alone)*100)
% 
% disp('Monotonicity only; CARA only')
% 
% disp(sum([MON_only CARA_only])/length(MON_only)*100)
% 
% disp('bounds on monotonicity')
% 
% disp(sum([MON_only MON_alone])/length(MON_only)*100)
% 
% disp('bounds on CARA- the lower bound pertains to positive r')
% disp('if you want to count with r zero need to add the respective number')
% 
% disp(sum([CARA_only CARA_alone])/length(MON_only)*100)
% 
% disp('bound lower bound on need both')
% 
% disp(sum(monotone-MON_only-CARA_alone )/length(MON_only)*100)
% 

var_MON_only          =    mean(MON_only)*mean(1-MON_only)/Num_Obs;
var_MON_alone         =    mean(MON_alone)*(1-mean(MON_alone))/Num_Obs;

[c_alpha_MON,f_MON]      =    fzero(@solve_for_critical_value,1.64,[],.05,mean(MON_only),mean(MON_alone),sqrt(var_MON_only),sqrt(var_MON_alone),Num_Obs);

MON_LB  =   mean(MON_only) -c_alpha_MON*sqrt(var_MON_only)/sqrt(Num_Obs);
MON_UB  =   mean(MON_alone)+c_alpha_MON*sqrt(var_MON_alone)/sqrt(Num_Obs);

%%%
var_CARA_only          =    mean(CARA_only)*mean(1-CARA_only)/Num_Obs;
var_CARA_alone         =    mean(CARA_alone)*(1-mean(CARA_alone))/Num_Obs;

[c_alpha_CARA,f_CARA]      =    fzero(@solve_for_critical_value,1.64,[],.05,mean(CARA_only),mean(CARA_alone),sqrt(var_CARA_only),sqrt(var_CARA_alone),Num_Obs);

CARA_LB  =   mean(CARA_only) -c_alpha_CARA*sqrt(var_CARA_only)/sqrt(Num_Obs);
CARA_UB  =   mean(CARA_alone)+c_alpha_CARA*sqrt(var_CARA_alone)/sqrt(Num_Obs);

EV_UB   =   EV_alone+1.64*sqrt(var_EV_alone)/sqrt(Num_Obs);

TOTAL_MON_only  = sum(monotone-MON_only-CARA_alone )/length(MON_only);
TOTAL_MON_alone = sum(monotone)/length(MON_only);


var_TOTAL_MON_only          =    mean(TOTAL_MON_only)*mean(1-TOTAL_MON_only)/Num_Obs;
var_TOTAL_MON_alone         =    mean(TOTAL_MON_alone)*(1-mean(TOTAL_MON_alone))/Num_Obs;
[c_alpha_TOTAL_MON,f_MON]      =    fzero(@solve_for_critical_value,1.64,[],.05,TOTAL_MON_only,TOTAL_MON_alone,sqrt(var_TOTAL_MON_only),sqrt(var_TOTAL_MON_alone),Num_Obs);

TOTAL_MON_LB  =   TOTAL_MON_only -c_alpha_TOTAL_MON*sqrt(var_TOTAL_MON_only)/sqrt(Num_Obs);
TOTAL_MON_UB  =   TOTAL_MON_alone+c_alpha_TOTAL_MON*sqrt(var_TOTAL_MON_alone)/sqrt(Num_Obs);

disp('%%%%%%%%%%%%%%')
disp('Table 5, Panel A')
disp(100*[ 0 EV_alone 0 EV_UB
  mean(CARA_only) mean(CARA_alone) CARA_LB CARA_UB
  mean(MON_only)  mean(MON_alone)  MON_LB MON_UB
  mean(TOTAL_MON_only) mean(TOTAL_MON_alone) TOTAL_MON_LB TOTAL_MON_UB])
%%


% we now compute: the union, the intersection and set diff
Both_CARA_and_GD     =   (CARA_alone+GD_alone==2);
Either_CARA_or_GD    =   (CARA_alone+GD_alone>0);
GD_only              =   GD_alone-CARA_alone==1;
CARA_only            =   CARA_alone-GD_alone==1;

% 
% disp('GD CARA Both Either')
% disp(sum([GD_alone CARA_alone Both_CARA_and_GD Either_CARA_or_GD])/length(GD_alone)*100)
% 
% disp('GD only; CARA only')
% 
% disp(sum([GD_only CARA_only])/length(GD_only)*100)
% 
% disp('bounds on GD')
% 
% disp(sum([GD_only GD_alone])/length(GD_only)*100)
% 
%%%





gd=sum(GD>0,2);

full_GD = gd>0;

% disp('Full GD')
% disp(sum(full_GD)/length(full_GD))


var_GD_only          =    mean(GD_only)*mean(1-GD_only)/Num_Obs;
var_GD_alone         =    mean(GD_alone)*(1-mean(GD_alone))/Num_Obs;

[c_alpha_GD,f_GD]      =    fzero(@solve_for_critical_value,1.64,[],.05,mean(GD_only),mean(GD_alone),sqrt(var_GD_only),sqrt(var_GD_alone),Num_Obs);

GD_LB  =   mean(GD_only) -c_alpha_GD*sqrt(var_GD_only)/sqrt(Num_Obs);
GD_UB  =   mean(GD_alone)+c_alpha_GD*sqrt(var_GD_alone)/sqrt(Num_Obs);

%%%
var_CARA_only          =    mean(CARA_only)*mean(1-CARA_only)/Num_Obs;
var_CARA_alone         =    mean(CARA_alone)*(1-mean(CARA_alone))/Num_Obs;

[c_alpha_CARA,f_CARA]      =    fzero(@solve_for_critical_value,1.64,[],.05,mean(CARA_only),mean(CARA_alone),sqrt(var_CARA_only),sqrt(var_CARA_alone),Num_Obs);

CARA_LB  =   mean(CARA_only) -c_alpha_CARA*sqrt(var_CARA_only)/sqrt(Num_Obs);
CARA_UB  =   mean(CARA_alone)+c_alpha_CARA*sqrt(var_CARA_alone)/sqrt(Num_Obs);

EV_UB   =   EV_alone+1.64*sqrt(var_EV_alone)/sqrt(Num_Obs);



TOTAL_GD_only  = sum(full_GD-GD_only-CARA_alone )/length(GD_only);
TOTAL_GD_alone = sum(full_GD)/length(GD_only);


var_TOTAL_GD_only          =    mean(TOTAL_GD_only)*mean(1-TOTAL_GD_only)/Num_Obs;
var_TOTAL_GD_alone         =    mean(TOTAL_GD_alone)*(1-mean(TOTAL_GD_alone))/Num_Obs;
[c_alpha_TOTAL_GD,f_GD]      =    fzero(@solve_for_critical_value,1.64,[],.05,TOTAL_GD_only,TOTAL_GD_alone,sqrt(var_TOTAL_GD_only),sqrt(var_TOTAL_GD_alone),Num_Obs);

TOTAL_GD_LB  =   TOTAL_GD_only -c_alpha_TOTAL_GD*sqrt(var_TOTAL_GD_only)/sqrt(Num_Obs);
TOTAL_GD_UB  =   TOTAL_GD_alone+c_alpha_TOTAL_GD*sqrt(var_TOTAL_GD_alone)/sqrt(Num_Obs);


disp('Table 5, Panel B')
disp(100*[ 0 EV_alone 0 EV_UB
  mean(CARA_only) mean(CARA_alone) CARA_LB CARA_UB
  mean(GD_only)   mean(GD_alone)   GD_LB   GD_UB
  mean(TOTAL_GD_only) mean(TOTAL_GD_alone) TOTAL_GD_LB TOTAL_GD_UB])


%%

% we now compute: the union, the intersection and set diff
Both_CARA_and_KR     =   (CARA_alone+KR_alone==2);
Either_CARA_or_KR    =   (CARA_alone+KR_alone>0);
KR_only              =   KR_alone-CARA_alone==1;
CARA_only            =   CARA_alone-KR_alone==1;


% disp('KR CARA Both Either')
% disp(sum([KR_alone CARA_alone Both_CARA_and_KR Either_CARA_or_KR])/length(KR_alone)*100)
% 
% disp('KR only; CARA only')
% 
% disp(sum([KR_only CARA_only])/length(KR_only)*100)
% 
% disp('bounds on KR')
% 
% disp(sum([KR_only KR_alone])/length(KR_only)*100)
% 

kr=sum(KR>0,2);

full_KR = kr>0;

% disp('Full KR')
% disp(sum(full_KR)/length(full_KR))

var_KR_only          =    mean(KR_only)*mean(1-KR_only)/Num_Obs;
var_KR_alone         =    mean(KR_alone)*(1-mean(KR_alone))/Num_Obs;

[c_alpha_KR,f_KR]      =    fzero(@solve_for_critical_value,1.64,[],.05,mean(KR_only),mean(KR_alone),sqrt(var_KR_only),sqrt(var_KR_alone),Num_Obs);

KR_LB  =   mean(KR_only) -c_alpha_KR*sqrt(var_KR_only)/sqrt(Num_Obs);
KR_UB  =   mean(KR_alone)+c_alpha_KR*sqrt(var_KR_alone)/sqrt(Num_Obs);

%%%
var_CARA_only          =    mean(CARA_only)*mean(1-CARA_only)/Num_Obs;
var_CARA_alone         =    mean(CARA_alone)*(1-mean(CARA_alone))/Num_Obs;

[c_alpha_CARA,f_CARA]      =    fzero(@solve_for_critical_value,1.64,[],.05,mean(CARA_only),mean(CARA_alone),sqrt(var_CARA_only),sqrt(var_CARA_alone),Num_Obs);

CARA_LB  =   mean(CARA_only) -c_alpha_CARA*sqrt(var_CARA_only)/sqrt(Num_Obs);
CARA_UB  =   mean(CARA_alone)+c_alpha_CARA*sqrt(var_CARA_alone)/sqrt(Num_Obs);

EV_UB   =   EV_alone+1.64*sqrt(var_EV_alone)/sqrt(Num_Obs);



TOTAL_KR_only  = sum(full_KR-KR_only-CARA_alone )/length(KR_only);
TOTAL_KR_alone = sum(full_KR)/length(KR_only);


var_TOTAL_KR_only          =    mean(TOTAL_KR_only)*mean(1-TOTAL_KR_only)/Num_Obs;
var_TOTAL_KR_alone         =    mean(TOTAL_KR_alone)*(1-mean(TOTAL_KR_alone))/Num_Obs;

[c_alpha_TOTAL_KR,f_KR]      =    fzero(@solve_for_critical_value,1.64,[],.05,TOTAL_KR_only,TOTAL_KR_alone,sqrt(var_TOTAL_KR_only),sqrt(var_TOTAL_KR_alone),Num_Obs);

TOTAL_KR_LB  =   TOTAL_KR_only -c_alpha_TOTAL_KR*sqrt(var_TOTAL_KR_only)/sqrt(Num_Obs);
TOTAL_KR_UB  =   TOTAL_KR_alone+c_alpha_TOTAL_KR*sqrt(var_TOTAL_KR_alone)/sqrt(Num_Obs);

disp('Table 5, Panel C')
disp(100*[ 0 EV_alone 0 EV_UB
  mean(CARA_only) mean(CARA_alone) CARA_LB CARA_UB
  mean(KR_only)   mean(KR_alone)   KR_LB   KR_UB
  mean(TOTAL_KR_only) mean(TOTAL_KR_alone) TOTAL_KR_LB TOTAL_KR_UB])
%%



% we now compute: the union, the intersection and set diff
Both_CARA_and_UNIT_SLOPE    =   (CARA_alone+UNIT_SLOPE_alone==2);
Either_CARA_or_UNIT_SLOPE   =   (CARA_alone+UNIT_SLOPE_alone>0);
UNIT_SLOPE_only             =   UNIT_SLOPE_alone-CARA_alone==1;
CARA_only                   =   CARA_alone-UNIT_SLOPE_alone==1;

% 
% disp('UNIT_SLOPE CARA Both Either')
% disp(sum([UNIT_SLOPE_alone CARA_alone Both_CARA_and_UNIT_SLOPE Either_CARA_or_UNIT_SLOPE])/length(UNIT_SLOPE_alone)*100)
% 
% disp('UNIT_SLOPE only; CARA only')
% 
% disp(sum([UNIT_SLOPE_only CARA_only])/length(UNIT_SLOPE_only)*100)
% 
% disp('bounds on UNIT_SLOPE')
% 
% disp(sum([UNIT_SLOPE_only UNIT_SLOPE_alone])/length(UNIT_SLOPE_only)*100)



unit_slope=sum(UNIT_SLOPE>0,2);

full_UNIT_SLOPE = unit_slope>0;

% disp('Full UNIT_SLOPE')
% disp(sum(full_UNIT_SLOPE)/length(full_UNIT_SLOPE))

var_UNIT_SLOPE_only          =    mean(UNIT_SLOPE_only)*mean(1-UNIT_SLOPE_only)/Num_Obs;
var_UNIT_SLOPE_alone         =    mean(UNIT_SLOPE_alone)*(1-mean(UNIT_SLOPE_alone))/Num_Obs;

[c_alpha_UNIT_SLOPE,f_UNIT_SLOPE]      =    fzero(@solve_for_critical_value,1.64,[],.05,mean(UNIT_SLOPE_only),mean(UNIT_SLOPE_alone),sqrt(var_UNIT_SLOPE_only),sqrt(var_UNIT_SLOPE_alone),Num_Obs);

UNIT_SLOPE_LB  =   mean(UNIT_SLOPE_only) -c_alpha_UNIT_SLOPE*sqrt(var_UNIT_SLOPE_only)/sqrt(Num_Obs);
UNIT_SLOPE_UB  =   mean(UNIT_SLOPE_alone)+c_alpha_UNIT_SLOPE*sqrt(var_UNIT_SLOPE_alone)/sqrt(Num_Obs);

%%%
var_CARA_only          =    mean(CARA_only)*mean(1-CARA_only)/Num_Obs;
var_CARA_alone         =    mean(CARA_alone)*(1-mean(CARA_alone))/Num_Obs;

[c_alpha_CARA,f_CARA]      =    fzero(@solve_for_critical_value,1.64,[],.05,mean(CARA_only),mean(CARA_alone),sqrt(var_CARA_only),sqrt(var_CARA_alone),Num_Obs);

CARA_LB  =   mean(CARA_only) -c_alpha_CARA*sqrt(var_CARA_only)/sqrt(Num_Obs);
CARA_UB  =   mean(CARA_alone)+c_alpha_CARA*sqrt(var_CARA_alone)/sqrt(Num_Obs);

EV_UB   =   EV_alone+1.64*sqrt(var_EV_alone)/sqrt(Num_Obs);



TOTAL_UNIT_SLOPE_only  = sum(full_UNIT_SLOPE-UNIT_SLOPE_only-CARA_alone )/length(UNIT_SLOPE_only);
TOTAL_UNIT_SLOPE_alone = sum(full_UNIT_SLOPE)/length(UNIT_SLOPE_only);


var_TOTAL_UNIT_SLOPE_only          =    mean(TOTAL_UNIT_SLOPE_only)*mean(1-TOTAL_UNIT_SLOPE_only)/Num_Obs;
var_TOTAL_UNIT_SLOPE_alone         =    mean(TOTAL_UNIT_SLOPE_alone)*(1-mean(TOTAL_UNIT_SLOPE_alone))/Num_Obs;

[c_alpha_TOTAL_UNIT_SLOPE,f_UNIT_SLOPE]      =    fzero(@solve_for_critical_value,1.64,[],.05,TOTAL_UNIT_SLOPE_only,TOTAL_UNIT_SLOPE_alone,sqrt(var_TOTAL_UNIT_SLOPE_only),sqrt(var_TOTAL_UNIT_SLOPE_alone),Num_Obs);

TOTAL_UNIT_SLOPE_LB  =   TOTAL_UNIT_SLOPE_only -c_alpha_TOTAL_UNIT_SLOPE*sqrt(var_TOTAL_UNIT_SLOPE_only)/sqrt(Num_Obs);
TOTAL_UNIT_SLOPE_UB  =   TOTAL_UNIT_SLOPE_alone+c_alpha_TOTAL_UNIT_SLOPE*sqrt(var_TOTAL_UNIT_SLOPE_alone)/sqrt(Num_Obs);

disp('Table 5, Panel D')
disp(100*[ 0 EV_alone 0 EV_UB
  mean(CARA_only) mean(CARA_alone) CARA_LB CARA_UB
  mean(UNIT_SLOPE_only)   mean(UNIT_SLOPE_alone)   UNIT_SLOPE_LB   UNIT_SLOPE_UB
  mean(TOTAL_UNIT_SLOPE_only) mean(TOTAL_UNIT_SLOPE_alone) TOTAL_UNIT_SLOPE_LB TOTAL_UNIT_SLOPE_UB])


%%



% we now compute: the union, the intersection and set diff
ALL_CARA_and_UNIT_SLOPE_and_KR    =   (CARA_alone+UNIT_SLOPE_alone+KR_alone+GD_alone==4);
Either_CARA_or_UNIT_SLOPE_or_KR   =   (CARA_alone+UNIT_SLOPE_alone+KR_alone+GD_alone>0);
UNIT_SLOPE_only                   =   UNIT_SLOPE_alone-(CARA_alone+KR_alone+GD_alone>0)==1;
CARA_only                         =   CARA_alone-(UNIT_SLOPE_alone+KR_alone+GD_alone>0)==1;
KR_only                           =   KR_alone  -(UNIT_SLOPE_alone+CARA_alone+GD_alone>0)==1;
GD_only                           =   GD_alone  -(UNIT_SLOPE_alone+CARA_alone+KR_alone>0)==1;

% 
% disp('UNIT_SLOPE CARA KR GD ALL Either')
% disp(sum([UNIT_SLOPE_alone CARA_alone KR_alone GD_alone ALL_CARA_and_UNIT_SLOPE_and_KR Either_CARA_or_UNIT_SLOPE_or_KR])/length(UNIT_SLOPE_alone)*100)
% 
% disp('UNIT_SLOPE only CARA only KR_only GD_only')
% 
% disp(sum([UNIT_SLOPE_only CARA_only KR_only GD_only])/length(UNIT_SLOPE_only)*100)

var_CARA_only          =    mean(CARA_only)*mean(1-CARA_only)/Num_Obs;
var_CARA_alone         =    mean(CARA_alone)*(1-mean(CARA_alone))/Num_Obs;

[c_alpha_CARA,f_CARA]      =    fzero(@solve_for_critical_value,1.64,[],.05,mean(CARA_only),mean(CARA_alone),sqrt(var_CARA_only),sqrt(var_CARA_alone),Num_Obs);

CARA_LB  =   mean(CARA_only) -c_alpha_CARA*sqrt(var_CARA_only)/sqrt(Num_Obs);
CARA_UB  =   mean(CARA_alone)+c_alpha_CARA*sqrt(var_CARA_alone)/sqrt(Num_Obs);


var_UNIT_SLOPE_only          =    mean(UNIT_SLOPE_only)*mean(1-UNIT_SLOPE_only)/Num_Obs;
var_UNIT_SLOPE_alone         =    mean(UNIT_SLOPE_alone)*(1-mean(UNIT_SLOPE_alone))/Num_Obs;

[c_alpha_UNIT_SLOPE,f_UNIT_SLOPE]      =    fzero(@solve_for_critical_value,1.64,[],.05,mean(UNIT_SLOPE_only),mean(UNIT_SLOPE_alone),sqrt(var_UNIT_SLOPE_only),sqrt(var_UNIT_SLOPE_alone),Num_Obs);

UNIT_SLOPE_LB  =   mean(UNIT_SLOPE_only) -c_alpha_UNIT_SLOPE*sqrt(var_UNIT_SLOPE_only)/sqrt(Num_Obs);
UNIT_SLOPE_UB  =   mean(UNIT_SLOPE_alone)+c_alpha_UNIT_SLOPE*sqrt(var_UNIT_SLOPE_alone)/sqrt(Num_Obs);



var_KR_only          =    mean(KR_only)*mean(1-KR_only)/Num_Obs;
var_KR_alone         =    mean(KR_alone)*(1-mean(KR_alone))/Num_Obs;

[c_alpha_KR,f_KR]      =    fzero(@solve_for_critical_value,1.64,[],.05,mean(KR_only),mean(KR_alone),sqrt(var_KR_only),sqrt(var_KR_alone),Num_Obs);

KR_LB  =   mean(KR_only) -c_alpha_KR*sqrt(var_KR_only)/sqrt(Num_Obs);
KR_UB  =   mean(KR_alone)+c_alpha_KR*sqrt(var_KR_alone)/sqrt(Num_Obs);



var_GD_only          =    mean(GD_only)*mean(1-GD_only)/Num_Obs;
var_GD_alone         =    mean(GD_alone)*(1-mean(GD_alone))/Num_Obs;

[c_alpha_GD,f_GD]      =    fzero(@solve_for_critical_value,1.64,[],.05,mean(GD_only),mean(GD_alone),sqrt(var_GD_only),sqrt(var_GD_alone),Num_Obs);

GD_LB  =   mean(GD_only) -c_alpha_GD*sqrt(var_GD_only)/sqrt(Num_Obs);
GD_UB  =   mean(GD_alone)+c_alpha_GD*sqrt(var_GD_alone)/sqrt(Num_Obs);



var_Either_CARA_or_UNIT_SLOPE_or_KR   =   mean(Either_CARA_or_UNIT_SLOPE_or_KR)*mean(1-Either_CARA_or_UNIT_SLOPE_or_KR)/Num_Obs;
Either_CARA_or_UNIT_SLOPE_or_KR_UB    =   mean(Either_CARA_or_UNIT_SLOPE_or_KR)+1.64*sqrt(var_Either_CARA_or_UNIT_SLOPE_or_KR)/sqrt(Num_Obs);


disp('Table 5, Panel E')

disp(100*[mean(CARA_only) mean(CARA_alone) CARA_LB CARA_UB
 mean(KR_only) mean(KR_alone) KR_LB KR_UB
 mean(GD_only) mean(GD_alone) GD_LB GD_UB
 mean(UNIT_SLOPE_only)   mean(UNIT_SLOPE_alone) UNIT_SLOPE_LB UNIT_SLOPE_UB] )
 
 disp( 100*[mean(ALL_CARA_and_UNIT_SLOPE_and_KR)
        mean(Either_CARA_or_UNIT_SLOPE_or_KR_UB)])


