deducs_matrix = [comp_deduc coll_deduc home_deduc];
prem_matrix   = [comp_prem  coll_prem  home_prem];
for ii=1:length(deducs_matrix)
    deducs_matrix(ii,:) = deducs_matrix(ii,index(ii,:));
    prem_matrix(ii,:)   = prem_matrix(ii,index(ii,:));
end

for ii=1:length(deducs_matrix)
 comp_L(ii) = LBSrawxx(ii,lambdas(ii,:)==lambda_comp(ii));
 comp_U(ii) = UBSrawxx(ii,lambdas(ii,:)==lambda_comp(ii));
 coll_L(ii) = LBSrawxx(ii,lambdas(ii,:)==lambda_coll(ii));
 coll_U(ii) = UBSrawxx(ii,lambdas(ii,:)==lambda_coll(ii));
 home_L(ii) = LBSrawxx(ii,lambdas(ii,:)==lambda_home(ii));
 home_U(ii) = UBSrawxx(ii,lambdas(ii,:)==lambda_home(ii));
 
 eps_comp_L(ii)= Epsilon_L(ii,lambdas(ii,:)==lambda_comp(ii)); 
 eps_comp_U(ii)= Epsilon_U(ii,lambdas(ii,:)==lambda_comp(ii)); 
 eps_coll_L(ii)= Epsilon_L(ii,lambdas(ii,:)==lambda_coll(ii)); 
 eps_coll_U(ii)= Epsilon_U(ii,lambdas(ii,:)==lambda_coll(ii)); 
 eps_home_L(ii)= Epsilon_L(ii,lambdas(ii,:)==lambda_home(ii)); 
 eps_home_U(ii)= Epsilon_U(ii,lambdas(ii,:)==lambda_home(ii)); 
end

parfor ii=1:length(deducs_matrix)
 [U_comp_max_L(ii),check_comp_L(ii)] = max(-pp_comp(ii,:)-deduc_list_comp*(comp_L(ii)+1e-3));
 [U_comp_max_U(ii),check_comp_U(ii)] = max(-pp_comp(ii,:)-deduc_list_comp*(comp_U(ii)-1e-3));
 [U_coll_max_L(ii),check_coll_L(ii)] = max(-pp_coll(ii,:)-deduc_list_coll*(coll_L(ii)+1e-3));
 [U_coll_max_U(ii),check_coll_U(ii)] = max(-pp_coll(ii,:)-deduc_list_coll*(coll_U(ii)-1e-3));
 [U_home_max_L(ii),check_home_L(ii)] = max(-pp_home(ii,:)-deduc_list_home*(home_L(ii)+1e-3));
 [U_home_max_U(ii),check_home_U(ii)] = max(-pp_home(ii,:)-deduc_list_home*(home_U(ii)-1e-3));
end

delta_U_comp_L_max = U_comp_max_L'- (-comp_prem-comp_deduc.*comp_L')+eps_comp_L'.*comp_deduc;
delta_U_comp_U_max = U_comp_max_U'- (-comp_prem-comp_deduc.*comp_U')+eps_comp_U'.*comp_deduc;

delta_U_coll_L_max = U_coll_max_L'- (-coll_prem-coll_deduc.*coll_L')+eps_coll_L'.*coll_deduc;
delta_U_coll_U_max = U_coll_max_U'- (-coll_prem-coll_deduc.*coll_U')+eps_coll_U'.*coll_deduc;

delta_U_home_L_max = U_home_max_L'- (-home_prem-home_deduc.*home_L')+eps_home_L'.*home_deduc;
delta_U_home_U_max = U_home_max_U'- (-home_prem-home_deduc.*home_U')+eps_home_U'.*home_deduc;


subplot 311
plot([deduc_list_comp(check_comp_U(monotone==1.*(RR_Mins_Monotone==RR_vec(1))))' deduc_list_comp(check_comp_L(monotone==1.*(RR_Mins_Monotone==RR_vec(1))))' comp_deduc(monotone==1.*(RR_Mins_Monotone==RR_vec(1)))])
subplot 312
plot([deduc_list_home(check_home_U(monotone==1.*(RR_Mins_Monotone==RR_vec(1))))' deduc_list_home(check_home_L(monotone==1.*(RR_Mins_Monotone==RR_vec(1))))' home_deduc(monotone==1.*(RR_Mins_Monotone==RR_vec(1)))])
subplot 313
plot([ deduc_list_coll(check_coll_L(monotone==1.*(RR_Mins_Monotone==RR_vec(1))))' deduc_list_coll(check_coll_L(monotone==1.*(RR_Mins_Monotone==RR_vec(1))))' coll_deduc(monotone==1.*(RR_Mins_Monotone==RR_vec(1)))])


figure
subplot 321
plot(sort(delta_U_comp_L_max(monotone==0)))
hold on
plot(sort(delta_U_comp_U_max(monotone==0)),'r')

subplot 322
plot(sort(delta_U_comp_L_max(monotone==0)./ U_comp_max_L(monotone==0)'))
hold on
plot(sort(delta_U_comp_U_max(monotone==0)./ U_comp_max_U(monotone==0)'),'g')

subplot 323
plot(sort(delta_U_coll_L_max(monotone==0)))
hold on
plot(sort(delta_U_coll_U_max(monotone==0)),'r')

subplot 324
plot(sort(delta_U_coll_L_max(monotone==0)./ U_coll_max_L(monotone==0)'))
hold on
plot(sort(delta_U_coll_U_max(monotone==0)./ U_coll_max_U(monotone==0)'),'g')


subplot 325
plot(sort(delta_U_home_L_max(monotone==0)))
hold on
plot(sort(delta_U_home_U_max(monotone==0)),'r')

subplot 326
plot(sort(delta_U_home_L_max(monotone==0)./ U_home_max_L(monotone==0)'))
hold on
plot(sort(delta_U_home_U_max(monotone==0)./ U_home_max_U(monotone==0)'),'g')


mean(delta_U_home_L_max(monotone==0))
mean(delta_U_home_U_max(monotone==0))
mean(delta_U_coll_L_max(monotone==0))
mean(delta_U_comp_U_max(monotone==0))

keyboard

