function [length_vec,xi_vec, yi_vec] = find_vertices(UB_1_vec,LB_1_vec,UB_2_vec,LB_2_vec,UB_3_vec,LB_3_vec,mu_1_vec,mu_2_vec,mu_3_vec,~,~)

NN          =   12;
xi_vec      =   zeros(length(UB_1_vec),NN);
yi_vec      =   zeros(length(UB_1_vec),NN);
length_vec  =   zeros(length(UB_1_vec),1 );

parfor ii=1:length(UB_1_vec)
    
    warning('off','map:vectorsToGPC:noExternalContours')

    UB_1 = UB_1_vec(ii);
    LB_1 = LB_1_vec(ii);
    
    UB_2 = UB_2_vec(ii);
    LB_2 = LB_2_vec(ii);
    
    UB_3 = UB_3_vec(ii);
    LB_3 = LB_3_vec(ii);
    
    mu_1 = mu_1_vec(ii);
    mu_2 = mu_2_vec(ii);
    mu_3 = mu_3_vec(ii);
    
    %% Second, we need the intersection of the third interval with the lower bounds on a and b, e.g. zero
    lower_a =   -1e+1;
    lower_b =   0;
    b_ver_1 = [   lower_b     (UB_1-lower_a)/mu_1 (LB_1-lower_a)/mu_1    lower_b  lower_b] ;
    a_ver_1 = [   UB_1        lower_a              lower_a               LB_1      UB_1  ] ;

    b_ver_2 = [   lower_b     (UB_2-lower_a)/mu_2 (LB_2-lower_a)/mu_2    lower_b  lower_b] ;
    a_ver_2 = [   UB_2        lower_a              lower_a               LB_2      UB_2  ] ;
    
    b_ver_3 = [   lower_b     (UB_3-lower_a)/mu_3 (LB_3-lower_a)/mu_3    lower_b  lower_b] ;
    a_ver_3 = [   UB_3        lower_a              lower_a               LB_3      UB_3  ] ;
    
    %%
    [b_ver_1, a_ver_1] = poly2cw(b_ver_1, a_ver_1);
    [b_ver_2, a_ver_2] = poly2cw(b_ver_2, a_ver_2);
    [b_ver_3, a_ver_3] = poly2cw(b_ver_3, a_ver_3);
    [xix, yix] = polybool('intersection', b_ver_1, a_ver_1, b_ver_2, a_ver_2);
    [xi, yi]   = polybool('intersection', b_ver_3, a_ver_3, xix ,     yix);
    
    length_vec(ii)  =   length(xi);
    if ~isempty(xi)
       
        xi_vec(ii,:)=[xi zeros(1,NN-length(xi))];
        yi_vec(ii,:)=[yi zeros(1,NN-length(xi))];
    else
    end
end