function r=ksr(x,y,h,N,x_grid)
if nargin<4
    N=100;
elseif ~isscalar(N)
    error('N must be a scalar.')
end

if nargin<5
    r.x=linspace(min(x),max(x),N);
else
    r.x=x_grid;
end



r.n=length(x);
if nargin<3
    % optimal bandwidth suggested by Bowman and Azzalini (1997) p.31
    hx=median(abs(x-median(x)))/0.6745*(4/3/r.n)^0.2;
    hy=median(abs(y-median(y)))/0.6745*(4/3/r.n)^0.2;
    h=sqrt(hy*hx);
    if h<sqrt(eps)*N
        error('There is no enough variation in the data. Regression is meaningless.')
    end
elseif ~isscalar(h)
    error('h must be a scalar.')
end
r.h=h;

% Gaussian kernel function - higher order 
kerf=@(z).5*(3-z.*z).*exp(-z.*z/2)/sqrt(2*pi);


r.f=zeros(1,N);
for k=1:N
    z=kerf((r.x(k)-x)/h);
    r.f(k)=sum(z.*y)/sum(z);
end