load data_04_01_10
%load data_12_13_10

alphahome           =   0.45;
alphacomp           =   0.57;
alphacoll           =   0.22;

lambda_home         =   lambda_home_1;
lambda_comp         =   lambda_comp_1./exp(HAS_VEH_2*.6539+HAS_VEH_3PLUS*.8812);
lambda_coll         =   lambda_coll_1./exp(HAS_VEH_2*.5992+HAS_VEH_3PLUS*.7327);

gamm_1comp          =   1/alphacomp+tot_comp_claims;
gamm_2comp          =   alphacomp./(1+alphacomp*tot_lambda_comp);

gamm_1coll          =   1/alphacoll+tot_coll_claims;
gamm_2coll          =   alphacoll./(1+alphacoll*tot_lambda_coll);

gamm_1home          =   1/alphahome+tot_home_claims;
gamm_2home          =   alphahome./(1+alphahome*tot_lambda_home);
% % Step 2: We report some Sample Stats:
% display('average annualized claim rates: home coll and comp')
% disp(mean([lambda_home lambda_coll lambda_comp]))
% display('average annualized premiums paid: home coll and comp')
% disp(mean([ home_prem    coll_prem comp_prem]))
% display('average deductible chosen: home coll and comp')
% disp(mean([ home_deduc   coll_deduc comp_deduc]))

lambda_home         =   lambda_home.*gamm_1home.*gamm_2home;
lambda_comp         =   lambda_comp.*gamm_1comp.*gamm_2comp;
lambda_coll         =   lambda_coll.*gamm_1coll.*gamm_2coll;

lambda_comp_matrix  =   lambda_comp;
lambda_coll_matrix  =   lambda_coll;
lambda_home_matrix  =   lambda_home;
weight_comp_matrix  =   1+0*lambda_comp_matrix;
weight_coll_matrix  =   1+0*lambda_coll_matrix;
weight_home_matrix  =   1+0*lambda_home_matrix;

draw_sub_sample =   0;
Sample_Size     =   length(coll_price_200);
Sub_Sample_Size =   round(Sample_Size)*1;
pp_home     =  [              home_price_100                home_price_250 home_price_500 home_price_1000 home_price_2500 home_price_5000];
pp_coll     =  [              coll_price_100 coll_price_200 coll_price_250 coll_price_500 coll_price_1000];
pp_comp     =  [comp_price_50 comp_price_100 comp_price_200 comp_price_250 comp_price_500 comp_price_1000];

clear home_price_100                home_price_250 home_price_500 home_price_1000 home_price_2500 home_price_5000
clear coll_price_100 coll_price_200 coll_price_250 coll_price_500 coll_price_1000
clear comp_price_50  comp_price_100 comp_price_200 comp_price_250 comp_price_500 comp_price_1000

if      draw_sub_sample==1

    perm            =    randperm(Sub_Sample_Size);

    home_deduc      =    home_deduc(perm(1:Sub_Sample_Size));
    coll_deduc      =    coll_deduc(perm(1:Sub_Sample_Size));
    comp_deduc      =    comp_deduc(perm(1:Sub_Sample_Size));

    home_prem       =    home_prem(perm(1:Sub_Sample_Size));
    coll_prem       =    coll_prem(perm(1:Sub_Sample_Size));
    comp_prem       =    comp_prem(perm(1:Sub_Sample_Size));

    lambda_home     =    lambda_home(perm(1:Sub_Sample_Size));
    lambda_coll     =    lambda_coll(perm(1:Sub_Sample_Size));
    lambda_comp     =    lambda_comp(perm(1:Sub_Sample_Size));

    
    drv_age         =    drv_age(perm(1:Sub_Sample_Size));
    female          =    female(perm(1:Sub_Sample_Size));
    single_dummy    =    single_dummy(perm(1:Sub_Sample_Size));
    married_dummy   =    married_dummy(perm(1:Sub_Sample_Size));
    peter           =    peter(perm(1:Sub_Sample_Size));
    home_value      =    home_value(perm(1:Sub_Sample_Size));

    pp_home         =    pp_home(perm(1:Sub_Sample_Size),:);
    pp_coll         =    pp_coll(perm(1:Sub_Sample_Size),:);
    pp_comp         =    pp_comp(perm(1:Sub_Sample_Size),:);

    display('in our random sub sample')
    display('average annualized claim rates: home coll and comp')
    disp(mean([lambda_home lambda_coll lambda_comp]))
    display('average annualized premiums paid: home coll and comp')
    disp(mean([ home_prem    coll_prem comp_prem]))
    display('average deductible chosen: home coll and comp')
    disp(mean([ home_deduc   coll_deduc comp_deduc]))


end
if take_two_hundred_out==1
    Sub_Sample = find(coll_deduc~=200);
else
    Sub_Sample = [];
end
if  length(Sub_Sample)>1
    Sub_Sample_Size = length(Sub_Sample);
    Sample_Size     = length(Sub_Sample);  


    home_deduc      =    home_deduc(Sub_Sample);
    coll_deduc      =    coll_deduc(Sub_Sample);
    comp_deduc      =    comp_deduc(Sub_Sample);

    home_prem       =    home_prem(Sub_Sample);
    coll_prem       =    coll_prem(Sub_Sample);
    comp_prem       =    comp_prem(Sub_Sample);

    lambda_home     =    lambda_home(Sub_Sample);
    lambda_coll     =    lambda_coll(Sub_Sample);
    lambda_comp     =    lambda_comp(Sub_Sample);
   
    gamm_1comp          =   gamm_1comp(Sub_Sample);
    gamm_2comp          =   gamm_2comp(Sub_Sample);
    
    gamm_1coll          =   gamm_1coll(Sub_Sample);
    gamm_2coll          =   gamm_2coll(Sub_Sample);
    
    gamm_1home          =   gamm_1home(Sub_Sample);
    gamm_2home          =   gamm_2home(Sub_Sample);

    lambda_comp_matrix  =   lambda_comp_matrix(Sub_Sample,:);
    lambda_coll_matrix  =   lambda_coll_matrix(Sub_Sample,:);
    lambda_home_matrix  =   lambda_home_matrix(Sub_Sample,:);
    weight_comp_matrix  =   weight_comp_matrix(Sub_Sample,:);
    weight_coll_matrix  =   weight_coll_matrix(Sub_Sample,:);
    weight_home_matrix  =   weight_home_matrix(Sub_Sample,:);


    drv_age1        =    drv_age1(Sub_Sample);
    female1         =    female1(Sub_Sample);
    single_dummy1   =    single_dummy1(Sub_Sample);
    married_dummy1  =    married_dummy1(Sub_Sample);
    peter           =    peter(Sub_Sample);
    home_value      =    home_value(Sub_Sample);

    pp_home         =    pp_home(Sub_Sample,:);
    pp_coll         =    pp_coll(Sub_Sample,:);
    pp_comp         =    pp_comp(Sub_Sample,:);
    
    young_driver    =    young_driver(Sub_Sample);
    drv_age2        =    drv_age2(Sub_Sample);
    female2         =    female2(Sub_Sample);
    single_dummy2   =    single_dummy2(Sub_Sample);
    married_dummy2  =    married_dummy2(Sub_Sample);
    HAS_DRV_2       =    HAS_DRV_2(Sub_Sample);
    HAS_DRV_3PLUS   =    HAS_DRV_3PLUS(Sub_Sample);

%     display('in our random sub sample')
%     display('average annualized claim rates: home coll and comp')
%     disp(mean([lambda_home lambda_coll lambda_comp]))
%     display('average annualized premiums paid: home coll and comp')
%     disp(mean([ home_prem    coll_prem comp_prem]))
%     display('average deductible chosen: home coll and comp')
%     disp(mean([ home_deduc   coll_deduc comp_deduc]))


end

%%%%%%%% Trasform to Fit the Likelihood Routine %%%%%%%%%%%%%%%%%%%%%%%%%%%
% Step 1: Deductible Menues
%These are the "full" deductible menues
deduc_list_home =    [   100     250 500 1000 2500 5000] ;
deduc_list_coll =    [   100 200 250 500 1000];
deduc_list_comp =    [50 100 200 250 500 1000];

% which we may combine into fewer choices
resctrict_choices_home     =   [1 2 3 4    ];
resctrict_choices_coll     =   [1 2 3 4 5  ];
resctrict_choices_comp     =   [1 2 3 4 5 6];


deduc_list_home =    deduc_list_home(resctrict_choices_home);
deduc_list_coll =    deduc_list_coll(resctrict_choices_coll);
deduc_list_comp =    deduc_list_comp(resctrict_choices_comp);

home_deduc   =   home_deduc.*(1-(home_deduc>deduc_list_home(end)))+(home_deduc>deduc_list_home(end))*deduc_list_home(end);
home_deduc   =   home_deduc.*(1-(home_deduc<deduc_list_home(1)))+(home_deduc<deduc_list_home(1))*deduc_list_home(1);

coll_deduc   =   coll_deduc.*(1-(coll_deduc>deduc_list_coll(end)))+(coll_deduc>deduc_list_coll(end))*deduc_list_coll(end);
coll_deduc   =   coll_deduc.*(1-(coll_deduc<deduc_list_coll(1)))+(coll_deduc<deduc_list_coll(1))*deduc_list_coll(1);

comp_deduc   =   comp_deduc.*(1-(comp_deduc>deduc_list_comp(end)))+(comp_deduc>deduc_list_comp(end))*deduc_list_comp(end);
comp_deduc   =   comp_deduc.*(1-(comp_deduc<deduc_list_comp(1)))+(comp_deduc<deduc_list_comp(1))*deduc_list_comp(1);

% These are "full" prices which we combined into fewer choices
pp_home     =  pp_home(:,resctrict_choices_home);
pp_coll     =  pp_coll(:,resctrict_choices_coll);
pp_comp     =  pp_comp(:,resctrict_choices_comp);

dd_home     =  ((home_deduc*ones(1,length(deduc_list_home)))==(ones(Sub_Sample_Size,1)*deduc_list_home));
dd_coll     =  ((coll_deduc*ones(1,length(deduc_list_coll)))==(ones(Sub_Sample_Size,1)*deduc_list_coll));
dd_comp     =  ((comp_deduc*ones(1,length(deduc_list_comp)))==(ones(Sub_Sample_Size,1)*deduc_list_comp));

npv_home    =  -pp_home- lambda_home*deduc_list_home;
npv_coll    =  -pp_coll- lambda_coll*deduc_list_coll;
npv_comp    =  -pp_comp- lambda_comp*deduc_list_comp;

[~,max_npv_home]    =  max(npv_home,[],2);
[~,max_npv_coll]    =  max(npv_coll,[],2);
[~,max_npv_comp]    =  max(npv_comp,[],2);

HAS_DRV_2   =   HAS_DRV_2+HAS_DRV_3PLUS;
drv_age2(find(isnan(drv_age2)==1))  =  0; %#ok<FNDSB>
female2(find(isnan(female2)==1))     =  0; %#ok<FNDSB>
single_dummy2(find(isnan(single_dummy2)==1))    =  0; %#ok<FNDSB>
married_dummy2(find(isnan(married_dummy2)==1))  =  0; %#ok<FNDSB>
age_var = (drv_age1-mean(drv_age1))/std(drv_age1);
XX  =  [ones(Sub_Sample_Size,1)      age_var age_var.^2 (female1-mean(female1))/std(female1) (single_dummy1-mean(single_dummy1))/std(single_dummy1) (married_dummy1-mean(married_dummy1))/std(married_dummy1) (peter-mean(peter))/std(peter) (home_value-mean(home_value))/std(home_value)];
XX  =  [XX HAS_DRV_2];

XX_Clean  =  [ones(Sub_Sample_Size,1)      age_var age_var.^2 female1 single_dummy1 married_dummy1 peter home_value HAS_DRV_2];
