clear all
close all


take_two_hundred_out              =   0;

load_data

lambda_comp          =   1- exp(-lambda_comp);
lambda_coll          =   1- exp(-lambda_coll);
lambda_home          =   1- exp(-lambda_home);

r_step                =   .1;

r_max                 =   10.8;%20

RR_vec                =  [(r_max:-r_step:1+r_step)*1e-3 (10:-1:1)*1e-4 (10:-1:1)*1e-5 (10:-1:1)*1e-6 0];
RR_vec                =  unique(RR_vec);

LOWER_BAR            =  0;
UPPER_BAR            =  1;

Total_Num_Obs        =  length(lambda_comp);

PLAUSIBILITY         =  zeros(length(RR_vec),Total_Num_Obs);

parfor kk=1:length(RR_vec)
    tic
    RR= RR_vec(kk);
    [~,~,~,Plausibility] = test_04_06_15(lambda_comp,lambda_coll,lambda_home,pp_comp,pp_coll,pp_home,comp_prem,coll_prem,home_prem,deduc_list_comp,deduc_list_coll,deduc_list_home,...
        comp_deduc,coll_deduc,home_deduc,repmat(RR,Total_Num_Obs,1),LOWER_BAR,UPPER_BAR,Total_Num_Obs);
   
    PLAUSIBILITY(kk,:) = Plausibility;
end


plausible_sample =  find(sum(PLAUSIBILITY)>0);

lambda_comp      =  lambda_comp(plausible_sample,:);
lambda_coll      =  lambda_coll(plausible_sample,:);
lambda_home      =  lambda_home(plausible_sample,:);
pp_comp          =  pp_comp(plausible_sample,:);
pp_coll          =  pp_coll(plausible_sample,:);
pp_home          =  pp_home(plausible_sample,:);
comp_prem        =  comp_prem(plausible_sample,:);
coll_prem        =  coll_prem(plausible_sample,:);
home_prem        =  home_prem(plausible_sample,:);
comp_deduc       =  comp_deduc(plausible_sample,:);
coll_deduc       =  coll_deduc(plausible_sample,:);
home_deduc       =  home_deduc(plausible_sample,:);

Num_Obs          =  length(lambda_comp);

Q_EXITFLAG_min = zeros(length(RR_vec),Num_Obs,3);
Q_EXITFLAG_max = zeros(length(RR_vec),Num_Obs,3);
Q_Omega_min_out= zeros(length(RR_vec),Num_Obs,3);
Q_Omega_max_out= zeros(length(RR_vec),Num_Obs,3);
PLAUSIBILITY   = zeros(length(RR_vec),Num_Obs);
MONOTONICITY   = zeros(length(RR_vec),Num_Obs);
QUADRATICITY   = zeros(length(RR_vec),Num_Obs);
LINEAR         = zeros(length(RR_vec),Num_Obs);
UNIT_SLOPE     = zeros(length(RR_vec),Num_Obs);
CARA           = zeros(length(RR_vec),Num_Obs);
KR             = zeros(length(RR_vec),Num_Obs);
GD             = zeros(length(RR_vec),Num_Obs);

for kk=1
    
    RR= RR_vec(kk);
    [LBS,UBS,lambdas,Plausibility,Monotonicity] = test_04_06_15(lambda_comp,lambda_coll,lambda_home,pp_comp,pp_coll,pp_home,comp_prem,coll_prem,home_prem,deduc_list_comp,deduc_list_coll,deduc_list_home,...
        comp_deduc,coll_deduc,home_deduc,repmat(RR,Num_Obs,1),LOWER_BAR,UPPER_BAR,Num_Obs);
    
    LBS_b_eq_1      =   LBS-lambdas;
    UBS_b_eq_1      =   UBS-lambdas;
    
    LBS_b_eq_1      =   max(LBS_b_eq_1,[],2);
    UBS_b_eq_1      =   min(UBS_b_eq_1,[],2);
    
    UB_1_vec =     UBS(:,1);
    LB_1_vec =     LBS(:,1);
    mu_1_vec = lambdas(:,1);
    
    UB_2_vec =     UBS(:,2);
    LB_2_vec =     LBS(:,2);
    mu_2_vec = lambdas(:,2);
    
    UB_3_vec =     UBS(:,3);
    LB_3_vec =     LBS(:,3);
    mu_3_vec = lambdas(:,3);
    
    selector = Monotonicity;

    length_vec = find_vertices(UB_1_vec,LB_1_vec,UB_2_vec,LB_2_vec,UB_3_vec,LB_3_vec,mu_1_vec,mu_2_vec,mu_3_vec,10,1);

    LINEAR(kk,:)=(length_vec.*Monotonicity)>0;
    tic
    for jj =1:3
        disp(jj)
        parfor ii=1:length(lambdas)
          
            if selector(ii)==1
                [~,temp,temp_two] = linprog([1; lambdas(ii,jj);lambdas(ii,jj)^2], [1  mu_1_vec(ii)  mu_1_vec(ii)^2; 1   mu_2_vec(ii)  mu_2_vec(ii)^2 ; 1  mu_3_vec(ii)  mu_3_vec(ii)^2;...
                                                                                  -1 -mu_1_vec(ii) -mu_1_vec(ii)^2; -1 -mu_2_vec(ii) -mu_2_vec(ii)^2; -1 -mu_3_vec(ii) -mu_3_vec(ii)^2;...
                                                                                   0  -1 -2*lambdas(ii,jj)],...
                                                                                  [  UB_1_vec(ii);   UB_2_vec(ii);   UB_3_vec(ii);    -LB_1_vec(ii);   - LB_2_vec(ii);    -LB_3_vec(ii); 0],[],[],...
                                                                                  [-100000; 0; -100], [1;200000;200000],[0;1;0],optimset('Display','off', 'TolFun',1e-8));
                if temp_two==1
                    Q_Omega_min_out(kk,ii,jj)= temp;
                end
                Q_EXITFLAG_min(kk,ii,jj)=  temp_two;
                
                [~,temp,temp_two] = linprog([-1; -lambdas(ii,jj);-lambdas(ii,jj)^2],[1  mu_1_vec(ii)  mu_1_vec(ii)^2; 1   mu_2_vec(ii)  mu_2_vec(ii)^2 ; 1  mu_3_vec(ii)  mu_3_vec(ii)^2;...
                                                                                    -1 -mu_1_vec(ii) -mu_1_vec(ii)^2; -1 -mu_2_vec(ii) -mu_2_vec(ii)^2; -1 -mu_3_vec(ii) -mu_3_vec(ii)^2;...
                                                                                     0  -1 -2*lambdas(ii,jj)],...
                                                                                    [  UB_1_vec(ii);   UB_2_vec(ii);   UB_3_vec(ii);    -LB_1_vec(ii);   - LB_2_vec(ii);    -LB_3_vec(ii); 0],[],[],...
                                                                                    [-100000; 0; -100], [1;200000;200000],[0;1;0],optimset('Display','off', 'TolFun',1e-8));
            
                if temp_two==1
                    Q_Omega_max_out(kk,ii,jj)= -temp;
                end
                Q_EXITFLAG_max(kk,ii,jj)= temp_two;
            end
        end
    end
    toc
   
    
    LBS_KR      =   (LBS-lambdas)./(1-lambdas)./lambdas;
    UBS_KR      =   (UBS-lambdas)./(1-lambdas)./lambdas;
    
    LBS_KR      =   max(LBS_KR,[],2);
    UBS_KR      =   min(UBS_KR,[],2);
    
    
    LBS_GD      =   (LBS-lambdas)./(LBS.*(1-lambdas));
    UBS_GD      =   (UBS-lambdas)./(UBS.*(1-lambdas));
    
    LBS_GD      =   max(LBS_GD,[],2);
    UBS_GD      =   min(UBS_GD,[],2);
    
    temp      = sum(Q_EXITFLAG_max(kk,:,:)+Q_EXITFLAG_min(kk,:,:)==2,3);

    PLAUSIBILITY(kk,:) = Plausibility;
    QUADRATICITY(kk,:) = temp==3;
    MONOTONICITY(kk,:) = Monotonicity;
    UNIT_SLOPE(kk,:)   = UBS_b_eq_1>=LBS_b_eq_1+1e-8;
    CARA(kk,:)         = sum((UBS>=lambdas).*(LBS<=lambdas),2);
    KR(kk,:)           = (UBS_KR>=LBS_KR-1e-8).*(UBS_KR>=0);
    GD(kk,:)           = (UBS_GD>=LBS_GD-1e-8).*(UBS_GD>=0);
    
end
for kk=2:length(RR_vec)
    disp(kk)
    tic
    RR= RR_vec(kk);
    [LBS,UBS,lambdas,Plausibility,Monotonicity] = test_04_06_15(lambda_comp,lambda_coll,lambda_home,pp_comp,pp_coll,pp_home,comp_prem,coll_prem,home_prem,deduc_list_comp,deduc_list_coll,deduc_list_home,...
        comp_deduc,coll_deduc,home_deduc,repmat(RR,Num_Obs,1),LOWER_BAR,UPPER_BAR,Num_Obs);
   

    LBS_b_eq_1      =   LBS-lambdas;
    UBS_b_eq_1      =   UBS-lambdas;
    
    LBS_b_eq_1      =   max(LBS_b_eq_1,[],2);
    UBS_b_eq_1      =   min(UBS_b_eq_1,[],2);
    
    UB_1_vec =     UBS(:,1);
    LB_1_vec =     LBS(:,1);
    mu_1_vec = lambdas(:,1);
    
    UB_2_vec =     UBS(:,2);
    LB_2_vec =     LBS(:,2);
    mu_2_vec = lambdas(:,2);
    
    UB_3_vec =     UBS(:,3);
    LB_3_vec =     LBS(:,3);
    mu_3_vec = lambdas(:,3);
    
    quad_temp =  sum(QUADRATICITY(1:kk,:));
    selector  = Monotonicity.*(1-quad_temp)';
    
    length_vec = find_vertices(UB_1_vec,LB_1_vec,UB_2_vec,LB_2_vec,UB_3_vec,LB_3_vec,mu_1_vec,mu_2_vec,mu_3_vec,10,1);

    LINEAR(kk,:)=(length_vec.*Monotonicity)>0;

    for jj =1:3
        disp(jj)
        parfor ii=1:length(lambdas)
          
            if selector(ii)==1
                [~,temp,temp_two] = linprog([1; lambdas(ii,jj);lambdas(ii,jj)^2], [1  mu_1_vec(ii)  mu_1_vec(ii)^2; 1   mu_2_vec(ii)  mu_2_vec(ii)^2 ; 1  mu_3_vec(ii)  mu_3_vec(ii)^2;...
                                                                                  -1 -mu_1_vec(ii) -mu_1_vec(ii)^2; -1 -mu_2_vec(ii) -mu_2_vec(ii)^2; -1 -mu_3_vec(ii) -mu_3_vec(ii)^2;...
                                                                                   0  -1 -2*lambdas(ii,jj)],...
                                                                                  [  UB_1_vec(ii);   UB_2_vec(ii);   UB_3_vec(ii);    -LB_1_vec(ii);   - LB_2_vec(ii);    -LB_3_vec(ii); 0],[],[],...
                                                                                  [-100000; 0; -100], [1;200000;200000],[0;1;0],optimset('Display','off', 'TolFun',1e-8));
                if temp_two==1
                    Q_Omega_min_out(kk,ii,jj)= temp;
                end
                Q_EXITFLAG_min(kk,ii,jj)=  temp_two;
                
                [~,temp,temp_two] = linprog([-1; -lambdas(ii,jj);-lambdas(ii,jj)^2],[1  mu_1_vec(ii)  mu_1_vec(ii)^2; 1   mu_2_vec(ii)  mu_2_vec(ii)^2 ; 1  mu_3_vec(ii)  mu_3_vec(ii)^2;...
                                                                                    -1 -mu_1_vec(ii) -mu_1_vec(ii)^2; -1 -mu_2_vec(ii) -mu_2_vec(ii)^2; -1 -mu_3_vec(ii) -mu_3_vec(ii)^2;...
                                                                                     0  -1 -2*lambdas(ii,jj)],...
                                                                                    [  UB_1_vec(ii);   UB_2_vec(ii);   UB_3_vec(ii);    -LB_1_vec(ii);   - LB_2_vec(ii);    -LB_3_vec(ii); 0],[],[],...
                                                                                    [-100000; 0; -100], [1;200000;200000],[0;1;0],optimset('Display','off', 'TolFun',1e-8));
            
                if temp_two==1
                    Q_Omega_max_out(kk,ii,jj)= -temp;
                end
                Q_EXITFLAG_max(kk,ii,jj)= temp_two;
            end
        end
    end
    toc
   
    
    LBS_KR      =   (LBS-lambdas)./(1-lambdas)./lambdas;
    UBS_KR      =   (UBS-lambdas)./(1-lambdas)./lambdas;
    
    LBS_KR      =   max(LBS_KR,[],2);
    UBS_KR      =   min(UBS_KR,[],2);
    
    
    LBS_GD      =   (LBS-lambdas)./(LBS.*(1-lambdas));
    UBS_GD      =   (UBS-lambdas)./(UBS.*(1-lambdas));
    
    LBS_GD      =   max(LBS_GD,[],2);
    UBS_GD      =   min(UBS_GD,[],2);
    
    PLAUSIBILITY(kk,:) = Plausibility;
    MONOTONICITY(kk,:) = Monotonicity;
    UNIT_SLOPE(kk,:)   = UBS_b_eq_1>=LBS_b_eq_1+1e-8;
    CARA(kk,:)         = sum((UBS>=lambdas).*(LBS<=lambdas),2);
    KR(kk,:)           = (UBS_KR>=LBS_KR-1e-8).*(UBS_KR>=0);
    GD(kk,:)           = (UBS_GD>=LBS_GD-1e-8).*(UBS_GD>=0);
    
end

UNIT_SLOPE  =   UNIT_SLOPE.*MONOTONICITY.*PLAUSIBILITY;
KR          =   KR.*PLAUSIBILITY.*MONOTONICITY;
GD          =   GD.*PLAUSIBILITY.*MONOTONICITY;

temp      = sum(Q_EXITFLAG_max+Q_EXITFLAG_min==2,3);
QUADRATIC = temp==3;
CARA      = CARA==3;

PLAUSIBILITY    =   PLAUSIBILITY'; 
MONOTONICITY    =   MONOTONICITY';
LINEAR          =   LINEAR';
QUADRATIC       =   QUADRATIC'; 
UNIT_SLOPE      =   UNIT_SLOPE';
CARA            =   CARA';
KR              =   KR';
GD              =   GD';


plausible    =  sum(PLAUSIBILITY==1,2)>0; 
monotone     =  sum(MONOTONICITY==1,2)>0; 
linear       =  sum(LINEAR   ==1,2)>0; 
quadratic    =  sum(QUADRATIC==1,2)>0; 
unit_slope   =  sum(UNIT_SLOPE==1,2)>0; 
cara         =  sum(CARA==1,2)>0; 
kr           =  sum(KR==1,2)>0;
gd           =  sum(GD==1,2)>0;



disp('%%%%%%%%%%%%%%%%%%%%%%%')
disp('Table 4, Column A')
disp('Plausibility, Monotonicity, Quadraticity, Linear, Unit Slope, CARA')
disp(num2str(sum(plausible)/Num_Obs*100,4) )
disp(num2str(sum(monotone)/Num_Obs*100 ,4) )
disp(num2str(sum(quadratic)/Num_Obs*100 ,4 ))
disp(num2str(sum(linear)/Num_Obs*100 ,4 ))
disp(num2str(sum(unit_slope)/Num_Obs*100 ,4 ))
disp(num2str(sum(cara)/Num_Obs*100 ,4 ))

disp('%%%%%%%%%%%%%%%%%%%%%%%')



RR_Mins_Plausible     =  zeros(Num_Obs,1);
RR_Mins_Monotone      =  zeros(Num_Obs,1);
RR_Mins_Quadratic     =  zeros(Num_Obs,1);
RR_Mins_Linear        =  zeros(Num_Obs,1);
RR_Mins_Unit_Slope    =  zeros(Num_Obs,1);
RR_Mins_CARA          =  zeros(Num_Obs,1);

% this creates the smallest distribution of r consistent with a given criterion
% we will be working now with a fully plausible sameple - so for all the
% RR_Mins the default will be the lowest plausible r

for ii=1:Num_Obs
    if plausible(ii)==1  
        temp                           =   find(PLAUSIBILITY(ii,:)==1);
        RR_Mins_Plausible(ii)          =   RR_vec(temp(1));
    else
        RR_Mins_Plausible(ii)          =   RR_vec(1);
    end
end


for ii=1:Num_Obs
    if monotone(ii) ==1
        temp                           =   find(MONOTONICITY(ii,:)==1);
        RR_Mins_Monotone(ii)           =   RR_vec(temp(1));
    elseif plausible(ii)==1  
        temp                           =   find(PLAUSIBILITY(ii,:)==1);
        RR_Mins_Monotone(ii)           =   RR_vec(temp(1));
    else
        RR_Mins_Monotone(ii)           =   RR_vec(1);
    end
end


for ii=1:Num_Obs
    if quadratic(ii) ==1
        temp                           =   find(QUADRATIC(ii,:)==1);
        RR_Mins_Quadratic(ii)          =   RR_vec(temp(1));
    elseif plausible(ii)==1  
        temp                           =   find(PLAUSIBILITY(ii,:)==1);
        RR_Mins_Quadratic(ii)          =   RR_vec(temp(1));
    else
        RR_Mins_Quadratic(ii)          =   RR_vec(1);
    end
end

for ii=1:Num_Obs
    if linear(ii) ==1
        temp                           =   find(LINEAR(ii,:)==1);
        RR_Mins_Linear(ii)             =   RR_vec(temp(1));
    elseif plausible(ii)==1  
        temp                           =   find(PLAUSIBILITY(ii,:)==1);
        RR_Mins_Linear(ii)             =   RR_vec(temp(1));
    else
        RR_Mins_Linear(ii)             =   RR_vec(1);
    end
end

for ii=1:Num_Obs
    if unit_slope(ii) ==1
        temp                            =   find(UNIT_SLOPE(ii,:)==1);
        RR_Mins_Unit_Slope(ii)          =   RR_vec(temp(1));
    elseif plausible(ii)==1  
        temp                            =   find(PLAUSIBILITY(ii,:)==1);
        RR_Mins_Unit_Slope(ii)          =   RR_vec(temp(1));
    else
        RR_Mins_Unit_Slope(ii)          =   RR_vec(1);
    end
end

for ii=1:Num_Obs
    if cara(ii) ==1
        temp                           =   find(CARA(ii,:)==1);
        RR_Mins_CARA(ii)               =   RR_vec(temp(1));
    elseif plausible(ii)==1  
        temp                           =   find(PLAUSIBILITY(ii,:)==1);
        RR_Mins_CARA(ii)               =   RR_vec(temp(1));
    else
        RR_Mins_CARA(ii)               =   RR_vec(1);
    end
end


if r_max==10.8
    save tested_05_28_15
    Report_A_05_28_15x
    figure
    Report_A_05_28_15
else
    save long_tested_05_28_15
    Report_A_05_28_15
    break
end

%% ________________________________________________________________________

[LBS,UBS,lambdas,~,~,LBSraw,UBSraw]  = test_04_06_15(lambda_comp,lambda_coll,lambda_home,pp_comp,pp_coll,pp_home,comp_prem,coll_prem,home_prem,deduc_list_comp,deduc_list_coll,deduc_list_home,...
        comp_deduc,coll_deduc,home_deduc,RR_Mins_Linear,LOWER_BAR,UPPER_BAR,Num_Obs);
    

    
UB_1_vec =     UBS(linear,1);
LB_1_vec =     LBS(linear,1);
mu_1_vec = lambdas(linear,1);

UB_2_vec =     UBS(linear,2);
LB_2_vec =     LBS(linear,2);
mu_2_vec = lambdas(linear,2);

UB_3_vec =     UBS(linear,3);
LB_3_vec =     LBS(linear,3);
mu_3_vec = lambdas(linear,3);

lambdas_linear  = lambdas(linear,:);

    
[length_vec,xi_vec, yi_vec] = find_vertices(UB_1_vec,LB_1_vec,UB_2_vec,LB_2_vec,UB_3_vec,LB_3_vec,mu_1_vec,mu_2_vec,mu_3_vec,10,1);
disp(['the sucess in constructing the intervals is ' num2str(sum(length_vec>0)/length(length_vec)*100) '%'])


UB_1_vec =     UB_1_vec(length_vec>0);
LB_1_vec =     (LB_1_vec(length_vec>0));
mu_1_vec =     mu_1_vec(length_vec>0);

UB_2_vec =     UB_2_vec(length_vec>0);
LB_2_vec =     (LB_2_vec(length_vec>0));
mu_2_vec =     mu_2_vec(length_vec>0);


UB_3_vec =     UB_3_vec(length_vec>0);
LB_3_vec =     (LB_3_vec(length_vec>0));
mu_3_vec =     mu_3_vec(length_vec>0);

xi_vec          =   xi_vec(length_vec>0,:);
yi_vec          =   yi_vec(length_vec>0,:);
length_vec      =   length_vec(length_vec>0);

Omega_min_out   = zeros(length(xi_vec),3);
Omega_max_out   = zeros(length(xi_vec),3);
Omega_mean_out  = zeros(length(xi_vec),3);

lambdas_linear  = lambdas_linear(length_vec>0,:);
for jj =1:3
    for ii=1:length(Omega_mean_out)
        Omega_max_out(ii,jj) = max(yi_vec(ii,1:length_vec(ii))+lambdas_linear(ii,jj)*xi_vec(ii,1:length_vec(ii))); 
        Omega_min_out(ii,jj) = min(yi_vec(ii,1:length_vec(ii))+lambdas_linear(ii,jj)*xi_vec(ii,1:length_vec(ii)));
        Omega_mean_out(ii,jj)=mean(yi_vec(ii,1:length_vec(ii))+lambdas_linear(ii,jj)*xi_vec(ii,1:length_vec(ii)));
    end
end

Linear_Shrink    =(Omega_min_out-Omega_max_out)./(LBSraw(linear==1,:)    -UBSraw(linear==1,:)); % this is the interval reduction for linear case
Linear_Shrink_X  =(Omega_min_out-Omega_max_out)-(LBSraw(linear==1,:)     -UBSraw(linear==1,:)); % this is the interval reduction for linear case


QQ_Omega_min_out  = zeros(Num_Obs,3);
QQ_Omega_max_out  = zeros(Num_Obs,3);
for ii=1:Num_Obs
    if quadratic(ii) ==1
        temp                           =   find(QUADRATIC(ii,:)==1);
    else
        temp =1;
    end
    QQ_Omega_min_out(ii,:)= squeeze(Q_Omega_min_out(temp(1),ii,:));
    
    QQ_Omega_max_out(ii,:)= squeeze(Q_Omega_max_out(temp(1),ii,:));
end


[LBS,UBS,~,~,~,LBSraw,UBSraw]   = test_04_06_15(lambda_comp,lambda_coll,lambda_home,pp_comp,pp_coll,pp_home,comp_prem,coll_prem,home_prem,deduc_list_comp,deduc_list_coll,deduc_list_home,...
        comp_deduc,coll_deduc,home_deduc,RR_Mins_Monotone,LOWER_BAR,UPPER_BAR,Num_Obs);
    

Monotone_Shrink    =(LBS(monotone==1,:) -UBS(monotone==1,:))./(LBSraw(monotone==1,:) -UBSraw(monotone==1,:)); % this is the interval reduction for linear case
Monotone_Shrink_X  =(LBS(monotone==1,:) -UBS(monotone==1,:))-(LBSraw(monotone==1,:)  -UBSraw(monotone==1,:)); % this is the interval reduction for linear case


[~,~,~,~,~,LBSraw,UBSraw]  = test_04_06_15(lambda_comp,lambda_coll,lambda_home,pp_comp,pp_coll,pp_home,comp_prem,coll_prem,home_prem,deduc_list_comp,deduc_list_coll,deduc_list_home,...
        comp_deduc,coll_deduc,home_deduc,RR_Mins_Quadratic,LOWER_BAR,UPPER_BAR,Num_Obs);


Quadratic_Shrink   =(QQ_Omega_min_out(quadratic==1,:)-QQ_Omega_max_out(quadratic==1,:))./(LBSraw(quadratic==1,:)-UBSraw(quadratic==1,:)); % this is the interval reduction for linear case
Quadratic_Shrink_X =(QQ_Omega_min_out(quadratic==1,:)-QQ_Omega_max_out(quadratic==1,:))-(LBSraw(quadratic==1,:)-UBSraw(quadratic==1,:)); % this is the interval reduction for linear case

% 
[LBS,UBS,lambdas,~,~,LBSraw,UBSraw]  = test_04_06_15(lambda_comp,lambda_coll,lambda_home,pp_comp,pp_coll,pp_home,comp_prem,coll_prem,home_prem,deduc_list_comp,deduc_list_coll,deduc_list_home,...
        comp_deduc,coll_deduc,home_deduc,RR_Mins_Unit_Slope,LOWER_BAR,UPPER_BAR,Num_Obs);
%    
%     
LBS_b_eq_1      =   LBS-lambdas;
UBS_b_eq_1      =   UBS-lambdas;

LBS_b_eq_1      =   max(LBS_b_eq_1,[],2);
UBS_b_eq_1      =   min(UBS_b_eq_1,[],2);

LBS_unit_slope  =   repmat(LBS_b_eq_1,1,3)+lambdas;
UBS_unit_slope  =   repmat(UBS_b_eq_1,1,3)+lambdas;

Unit_Slope_Shrink    =(LBS_unit_slope(unit_slope==1,:) -UBS_unit_slope(unit_slope==1,:))./(LBSraw(unit_slope==1,:) -UBSraw(unit_slope==1,:)); % this is the interval reduction for linear case
Unit_Slope_Shrink_X  =(LBS_unit_slope(unit_slope==1,:) -UBS_unit_slope(unit_slope==1,:))-(LBSraw(unit_slope==1,:)  -UBSraw(unit_slope==1,:)); % this is the interval reduction for linear case


[LBS,UBS,lambdas,~,~,LBSraw,UBSraw]  = test_04_06_15(lambda_comp,lambda_coll,lambda_home,pp_comp,pp_coll,pp_home,comp_prem,coll_prem,home_prem,deduc_list_comp,deduc_list_coll,deduc_list_home,...
        comp_deduc,coll_deduc,home_deduc,RR_Mins_CARA,LOWER_BAR,UPPER_BAR,Num_Obs);

CARA_Shrink    =       -(LBSraw(cara==1,:) -UBSraw(cara==1,:)); % this is the interval reduction for linear case

disp('%%%%%%%%%%%%%%%%%%%%%%%')
disp('Table 4, Column B')

disp(num2str(100-mean(mean(Monotone_Shrink))*100,4))
disp(num2str(100-mean(mean(Quadratic_Shrink))*100,4))
disp(num2str(100-mean(mean(Linear_Shrink))*100,4))
disp(num2str(100-mean(mean(Unit_Slope_Shrink))*100,4))


disp(num2str(mean(mean(Monotone_Shrink_X))*100,4))
disp(num2str(mean(mean(Quadratic_Shrink_X))*100,4))
disp(num2str(mean(mean(Linear_Shrink_X))*100,4))
disp(num2str(mean(mean(Unit_Slope_Shrink_X))*100,4))
disp(num2str(mean(mean(CARA_Shrink))*100,4))

disp('%%%%%%%%%%%%%%%%%%%%%%%')


rng(123456)

Report_G_04_08_15
Report_B_05_28_15
Report_E_05_28_15
Report_C_05_28_15
