clear all
close all


take_two_hundred_out              =   0;




load_data

deduc_list_home =    [   100     250 500 750] ;
deduc_list_coll =    [   100 200 250 500 750];
deduc_list_comp =    [50 100 200 250 500 750];

comp_deduc(comp_deduc==1000) = 750; 
coll_deduc(coll_deduc==1000) = 750;
home_deduc(home_deduc==1000) = 750;

lambda_comp          =   1- exp(-lambda_comp);
lambda_coll          =   1- exp(-lambda_coll);
lambda_home          =   1- exp(-lambda_home);

r_step                =   .1;

r_max                 =   10.8;%20

RR_vec                =  [(r_max:-r_step:1+r_step)*1e-3 (10:-1:1)*1e-4 (10:-1:1)*1e-5 (10:-1:1)*1e-6 0];
RR_vec                =  unique(RR_vec);

LOWER_BAR            =  0;
UPPER_BAR            =  1;

Total_Num_Obs        =  length(lambda_comp);

PLAUSIBILITY         =  zeros(length(RR_vec),Total_Num_Obs);

parfor kk=1:length(RR_vec)
    tic
    RR= RR_vec(kk);
    [~,~,~,Plausibility] = test_04_06_15(lambda_comp,lambda_coll,lambda_home,pp_comp,pp_coll,pp_home,comp_prem,coll_prem,home_prem,deduc_list_comp,deduc_list_coll,deduc_list_home,...
        comp_deduc,coll_deduc,home_deduc,repmat(RR,Total_Num_Obs,1),LOWER_BAR,UPPER_BAR,Total_Num_Obs);
   
    PLAUSIBILITY(kk,:) = Plausibility;
end


plausible_sample =  find(sum(PLAUSIBILITY)>0);

lambda_comp      =  lambda_comp(plausible_sample,:);
lambda_coll      =  lambda_coll(plausible_sample,:);
lambda_home      =  lambda_home(plausible_sample,:);
pp_comp          =  pp_comp(plausible_sample,:);
pp_coll          =  pp_coll(plausible_sample,:);
pp_home          =  pp_home(plausible_sample,:);
comp_prem        =  comp_prem(plausible_sample,:);
coll_prem        =  coll_prem(plausible_sample,:);
home_prem        =  home_prem(plausible_sample,:);
comp_deduc       =  comp_deduc(plausible_sample,:);
coll_deduc       =  coll_deduc(plausible_sample,:);
home_deduc       =  home_deduc(plausible_sample,:);

Num_Obs          =  length(lambda_comp);

Q_EXITFLAG_min = zeros(length(RR_vec),Num_Obs,3);
Q_EXITFLAG_max = zeros(length(RR_vec),Num_Obs,3);
Q_Omega_min_out= zeros(length(RR_vec),Num_Obs,3);
Q_Omega_max_out= zeros(length(RR_vec),Num_Obs,3);
PLAUSIBILITY   = zeros(length(RR_vec),Num_Obs);
MONOTONICITY   = zeros(length(RR_vec),Num_Obs);
QUADRATICITY   = zeros(length(RR_vec),Num_Obs);
LINEAR         = zeros(length(RR_vec),Num_Obs);
UNIT_SLOPE     = zeros(length(RR_vec),Num_Obs);
CARA           = zeros(length(RR_vec),Num_Obs);
KR             = zeros(length(RR_vec),Num_Obs);
GD             = zeros(length(RR_vec),Num_Obs);

for kk=1
    
    RR= RR_vec(kk);
    [LBS,UBS,lambdas,Plausibility,Monotonicity] = test_04_06_15(lambda_comp,lambda_coll,lambda_home,pp_comp,pp_coll,pp_home,comp_prem,coll_prem,home_prem,deduc_list_comp,deduc_list_coll,deduc_list_home,...
        comp_deduc,coll_deduc,home_deduc,repmat(RR,Num_Obs,1),LOWER_BAR,UPPER_BAR,Num_Obs);
    
    LBS_b_eq_1      =   LBS-lambdas;
    UBS_b_eq_1      =   UBS-lambdas;
    
    LBS_b_eq_1      =   max(LBS_b_eq_1,[],2);
    UBS_b_eq_1      =   min(UBS_b_eq_1,[],2);
    
    UB_1_vec =     UBS(:,1);
    LB_1_vec =     LBS(:,1);
    mu_1_vec = lambdas(:,1);
    
    UB_2_vec =     UBS(:,2);
    LB_2_vec =     LBS(:,2);
    mu_2_vec = lambdas(:,2);
    
    UB_3_vec =     UBS(:,3);
    LB_3_vec =     LBS(:,3);
    mu_3_vec = lambdas(:,3);
    
    selector = Monotonicity;

    length_vec = find_vertices(UB_1_vec,LB_1_vec,UB_2_vec,LB_2_vec,UB_3_vec,LB_3_vec,mu_1_vec,mu_2_vec,mu_3_vec,10,1);

    LINEAR(kk,:)=(length_vec.*Monotonicity)>0;
    tic
    for jj =1:3
        disp(jj)
        parfor ii=1:length(lambdas)
          
            if selector(ii)==1
                [~,temp,temp_two] = linprog([1; lambdas(ii,jj);lambdas(ii,jj)^2], [1  mu_1_vec(ii)  mu_1_vec(ii)^2; 1   mu_2_vec(ii)  mu_2_vec(ii)^2 ; 1  mu_3_vec(ii)  mu_3_vec(ii)^2;...
                                                                                  -1 -mu_1_vec(ii) -mu_1_vec(ii)^2; -1 -mu_2_vec(ii) -mu_2_vec(ii)^2; -1 -mu_3_vec(ii) -mu_3_vec(ii)^2;...
                                                                                   0  -1 -2*lambdas(ii,jj)],...
                                                                                  [  UB_1_vec(ii);   UB_2_vec(ii);   UB_3_vec(ii);    -LB_1_vec(ii);   - LB_2_vec(ii);    -LB_3_vec(ii); 0],[],[],...
                                                                                  [-100000; 0; -100], [1;200000;200000],[0;1;0],optimset('Display','off', 'TolFun',1e-8));
                if temp_two==1
                    Q_Omega_min_out(kk,ii,jj)= temp;
                end
                Q_EXITFLAG_min(kk,ii,jj)=  temp_two;
                
                [~,temp,temp_two] = linprog([-1; -lambdas(ii,jj);-lambdas(ii,jj)^2],[1  mu_1_vec(ii)  mu_1_vec(ii)^2; 1   mu_2_vec(ii)  mu_2_vec(ii)^2 ; 1  mu_3_vec(ii)  mu_3_vec(ii)^2;...
                                                                                    -1 -mu_1_vec(ii) -mu_1_vec(ii)^2; -1 -mu_2_vec(ii) -mu_2_vec(ii)^2; -1 -mu_3_vec(ii) -mu_3_vec(ii)^2;...
                                                                                     0  -1 -2*lambdas(ii,jj)],...
                                                                                    [  UB_1_vec(ii);   UB_2_vec(ii);   UB_3_vec(ii);    -LB_1_vec(ii);   - LB_2_vec(ii);    -LB_3_vec(ii); 0],[],[],...
                                                                                    [-100000; 0; -100], [1;200000;200000],[0;1;0],optimset('Display','off', 'TolFun',1e-8));
            
                if temp_two==1
                    Q_Omega_max_out(kk,ii,jj)= -temp;
                end
                Q_EXITFLAG_max(kk,ii,jj)= temp_two;
            end
        end
    end
    toc
   
    
    LBS_KR      =   (LBS-lambdas)./(1-lambdas)./lambdas;
    UBS_KR      =   (UBS-lambdas)./(1-lambdas)./lambdas;
    
    LBS_KR      =   max(LBS_KR,[],2);
    UBS_KR      =   min(UBS_KR,[],2);
    
    
    LBS_GD      =   (LBS-lambdas)./(LBS.*(1-lambdas));
    UBS_GD      =   (UBS-lambdas)./(UBS.*(1-lambdas));
    
    LBS_GD      =   max(LBS_GD,[],2);
    UBS_GD      =   min(UBS_GD,[],2);
    
    temp      = sum(Q_EXITFLAG_max(kk,:,:)+Q_EXITFLAG_min(kk,:,:)==2,3);

    PLAUSIBILITY(kk,:) = Plausibility;
    QUADRATICITY(kk,:) = temp==3;
    MONOTONICITY(kk,:) = Monotonicity;
    UNIT_SLOPE(kk,:)   = UBS_b_eq_1>=LBS_b_eq_1+1e-8;
    CARA(kk,:)         = sum((UBS>=lambdas).*(LBS<=lambdas),2);
    KR(kk,:)           = (UBS_KR>=LBS_KR-1e-8).*(UBS_KR>=0);
    GD(kk,:)           = (UBS_GD>=LBS_GD-1e-8).*(UBS_GD>=0);
    
end
for kk=2:length(RR_vec)
    disp(kk)
    tic
    RR= RR_vec(kk);
    [LBS,UBS,lambdas,Plausibility,Monotonicity] = test_04_06_15(lambda_comp,lambda_coll,lambda_home,pp_comp,pp_coll,pp_home,comp_prem,coll_prem,home_prem,deduc_list_comp,deduc_list_coll,deduc_list_home,...
        comp_deduc,coll_deduc,home_deduc,repmat(RR,Num_Obs,1),LOWER_BAR,UPPER_BAR,Num_Obs);
   

    LBS_b_eq_1      =   LBS-lambdas;
    UBS_b_eq_1      =   UBS-lambdas;
    
    LBS_b_eq_1      =   max(LBS_b_eq_1,[],2);
    UBS_b_eq_1      =   min(UBS_b_eq_1,[],2);
    
    UB_1_vec =     UBS(:,1);
    LB_1_vec =     LBS(:,1);
    mu_1_vec = lambdas(:,1);
    
    UB_2_vec =     UBS(:,2);
    LB_2_vec =     LBS(:,2);
    mu_2_vec = lambdas(:,2);
    
    UB_3_vec =     UBS(:,3);
    LB_3_vec =     LBS(:,3);
    mu_3_vec = lambdas(:,3);
    
    quad_temp =  sum(QUADRATICITY(1:kk,:));
    selector  = Monotonicity.*(1-quad_temp)';
    
    length_vec = find_vertices(UB_1_vec,LB_1_vec,UB_2_vec,LB_2_vec,UB_3_vec,LB_3_vec,mu_1_vec,mu_2_vec,mu_3_vec,10,1);

    LINEAR(kk,:)=(length_vec.*Monotonicity)>0;

    for jj =1:3
        disp(jj)
        parfor ii=1:length(lambdas)
          
            if selector(ii)==1
                [~,temp,temp_two] = linprog([1; lambdas(ii,jj);lambdas(ii,jj)^2], [1  mu_1_vec(ii)  mu_1_vec(ii)^2; 1   mu_2_vec(ii)  mu_2_vec(ii)^2 ; 1  mu_3_vec(ii)  mu_3_vec(ii)^2;...
                                                                                  -1 -mu_1_vec(ii) -mu_1_vec(ii)^2; -1 -mu_2_vec(ii) -mu_2_vec(ii)^2; -1 -mu_3_vec(ii) -mu_3_vec(ii)^2;...
                                                                                   0  -1 -2*lambdas(ii,jj)],...
                                                                                  [  UB_1_vec(ii);   UB_2_vec(ii);   UB_3_vec(ii);    -LB_1_vec(ii);   - LB_2_vec(ii);    -LB_3_vec(ii); 0],[],[],...
                                                                                  [-100000; 0; -100], [1;200000;200000],[0;1;0],optimset('Display','off', 'TolFun',1e-8));
                if temp_two==1
                    Q_Omega_min_out(kk,ii,jj)= temp;
                end
                Q_EXITFLAG_min(kk,ii,jj)=  temp_two;
                
                [~,temp,temp_two] = linprog([-1; -lambdas(ii,jj);-lambdas(ii,jj)^2],[1  mu_1_vec(ii)  mu_1_vec(ii)^2; 1   mu_2_vec(ii)  mu_2_vec(ii)^2 ; 1  mu_3_vec(ii)  mu_3_vec(ii)^2;...
                                                                                    -1 -mu_1_vec(ii) -mu_1_vec(ii)^2; -1 -mu_2_vec(ii) -mu_2_vec(ii)^2; -1 -mu_3_vec(ii) -mu_3_vec(ii)^2;...
                                                                                     0  -1 -2*lambdas(ii,jj)],...
                                                                                    [  UB_1_vec(ii);   UB_2_vec(ii);   UB_3_vec(ii);    -LB_1_vec(ii);   - LB_2_vec(ii);    -LB_3_vec(ii); 0],[],[],...
                                                                                    [-100000; 0; -100], [1;200000;200000],[0;1;0],optimset('Display','off', 'TolFun',1e-8));
            
                if temp_two==1
                    Q_Omega_max_out(kk,ii,jj)= -temp;
                end
                Q_EXITFLAG_max(kk,ii,jj)= temp_two;
            end
        end
    end
    toc
   
    
    LBS_KR      =   (LBS-lambdas)./(1-lambdas)./lambdas;
    UBS_KR      =   (UBS-lambdas)./(1-lambdas)./lambdas;
    
    LBS_KR      =   max(LBS_KR,[],2);
    UBS_KR      =   min(UBS_KR,[],2);
    
    
    LBS_GD      =   (LBS-lambdas)./(LBS.*(1-lambdas));
    UBS_GD      =   (UBS-lambdas)./(UBS.*(1-lambdas));
    
    LBS_GD      =   max(LBS_GD,[],2);
    UBS_GD      =   min(UBS_GD,[],2);
    
    PLAUSIBILITY(kk,:) = Plausibility;
    MONOTONICITY(kk,:) = Monotonicity;
    UNIT_SLOPE(kk,:)   = UBS_b_eq_1>=LBS_b_eq_1+1e-8;
    CARA(kk,:)         = sum((UBS>=lambdas).*(LBS<=lambdas),2);
    KR(kk,:)           = (UBS_KR>=LBS_KR-1e-8).*(UBS_KR>=0);
    GD(kk,:)           = (UBS_GD>=LBS_GD-1e-8).*(UBS_GD>=0);
    
end

UNIT_SLOPE  =   UNIT_SLOPE.*MONOTONICITY.*PLAUSIBILITY;
KR          =   KR.*PLAUSIBILITY.*MONOTONICITY;
GD          =   GD.*PLAUSIBILITY.*MONOTONICITY;

temp      = sum(Q_EXITFLAG_max+Q_EXITFLAG_min==2,3);
QUADRATIC = temp==3;
CARA      = CARA==3;

PLAUSIBILITY    =   PLAUSIBILITY'; 
MONOTONICITY    =   MONOTONICITY';
LINEAR          =   LINEAR';
QUADRATIC       =   QUADRATIC'; 
UNIT_SLOPE      =   UNIT_SLOPE';
CARA            =   CARA';
KR              =   KR';
GD              =   GD';


plausible    =  sum(PLAUSIBILITY==1,2)>0; 
monotone     =  sum(MONOTONICITY==1,2)>0; 
linear       =  sum(LINEAR   ==1,2)>0; 
quadratic    =  sum(QUADRATIC==1,2)>0; 
unit_slope   =  sum(UNIT_SLOPE==1,2)>0; 
cara         =  sum(CARA==1,2)>0; 
kr           =  sum(KR==1,2)>0;
gd           =  sum(GD==1,2)>0;



disp('%%%%%%%%%%%%%%%%%%%%%%%')
disp('Table 4, Column A')
disp('Plausibility, Monotonicity, Quadraticity, Linear, Unit Slope, CARA')
disp(num2str(sum(plausible)/Num_Obs*100,4) )
disp(num2str(sum(monotone)/Num_Obs*100 ,4) )
disp(num2str(sum(quadratic)/Num_Obs*100 ,4 ))
disp(num2str(sum(linear)/Num_Obs*100 ,4 ))
disp(num2str(sum(unit_slope)/Num_Obs*100 ,4 ))
disp(num2str(sum(cara)/Num_Obs*100 ,4 ))

disp('%%%%%%%%%%%%%%%%%%%%%%%')



RR_Mins_Plausible     =  zeros(Num_Obs,1);
RR_Mins_Monotone      =  zeros(Num_Obs,1);
RR_Mins_Quadratic     =  zeros(Num_Obs,1);
RR_Mins_Linear        =  zeros(Num_Obs,1);
RR_Mins_Unit_Slope    =  zeros(Num_Obs,1);
RR_Mins_CARA          =  zeros(Num_Obs,1);

% this creates the smallest distribution of r consistent with a given criterion
% we will be working now with a fully plausible sameple - so for all the
% RR_Mins the default will be the lowest plausible r

for ii=1:Num_Obs
    if plausible(ii)==1  
        temp                           =   find(PLAUSIBILITY(ii,:)==1);
        RR_Mins_Plausible(ii)          =   RR_vec(temp(1));
    else
        RR_Mins_Plausible(ii)          =   RR_vec(1);
    end
end


for ii=1:Num_Obs
    if monotone(ii) ==1
        temp                           =   find(MONOTONICITY(ii,:)==1);
        RR_Mins_Monotone(ii)           =   RR_vec(temp(1));
    elseif plausible(ii)==1  
        temp                           =   find(PLAUSIBILITY(ii,:)==1);
        RR_Mins_Monotone(ii)           =   RR_vec(temp(1));
    else
        RR_Mins_Monotone(ii)           =   RR_vec(1);
    end
end


for ii=1:Num_Obs
    if quadratic(ii) ==1
        temp                           =   find(QUADRATIC(ii,:)==1);
        RR_Mins_Quadratic(ii)          =   RR_vec(temp(1));
    elseif plausible(ii)==1  
        temp                           =   find(PLAUSIBILITY(ii,:)==1);
        RR_Mins_Quadratic(ii)          =   RR_vec(temp(1));
    else
        RR_Mins_Quadratic(ii)          =   RR_vec(1);
    end
end

for ii=1:Num_Obs
    if linear(ii) ==1
        temp                           =   find(LINEAR(ii,:)==1);
        RR_Mins_Linear(ii)             =   RR_vec(temp(1));
    elseif plausible(ii)==1  
        temp                           =   find(PLAUSIBILITY(ii,:)==1);
        RR_Mins_Linear(ii)             =   RR_vec(temp(1));
    else
        RR_Mins_Linear(ii)             =   RR_vec(1);
    end
end

for ii=1:Num_Obs
    if unit_slope(ii) ==1
        temp                            =   find(UNIT_SLOPE(ii,:)==1);
        RR_Mins_Unit_Slope(ii)          =   RR_vec(temp(1));
    elseif plausible(ii)==1  
        temp                            =   find(PLAUSIBILITY(ii,:)==1);
        RR_Mins_Unit_Slope(ii)          =   RR_vec(temp(1));
    else
        RR_Mins_Unit_Slope(ii)          =   RR_vec(1);
    end
end

for ii=1:Num_Obs
    if cara(ii) ==1
        temp                           =   find(CARA(ii,:)==1);
        RR_Mins_CARA(ii)               =   RR_vec(temp(1));
    elseif plausible(ii)==1  
        temp                           =   find(PLAUSIBILITY(ii,:)==1);
        RR_Mins_CARA(ii)               =   RR_vec(temp(1));
    else
        RR_Mins_CARA(ii)               =   RR_vec(1);
    end
end


RR_plotter      = 0:1e-3:1.1e-2;

hist_Monotone   = hist(RR_Mins_Monotone(monotone==1)  ,RR_plotter);
hist_Quad       = hist(RR_Mins_Quadratic(quadratic==1),RR_plotter);
hist_Linear     = hist(RR_Mins_Linear(linear==1),RR_plotter);
hist_Unit_Slope = hist(RR_Mins_Unit_Slope(unit_slope==1),RR_plotter);
hist_CARA       = hist(RR_Mins_CARA(cara==1),RR_plotter);




mean_Monotone   = mean(RR_Mins_Monotone(monotone==1)  )*1000;
mean_Quad       = mean(RR_Mins_Quadratic(quadratic==1))*1000;
mean_Linear     = mean(RR_Mins_Linear(linear==1))*1000;
mean_Unit_Slope = mean(RR_Mins_Unit_Slope(unit_slope==1))*1000;
mean_CARA       = mean(RR_Mins_CARA(cara==1))*1000;


std_Monotone   = std(RR_Mins_Monotone(monotone==1)  )*1000;
std_Quad       = std(RR_Mins_Quadratic(quadratic==1))*1000;
std_Linear     = std(RR_Mins_Linear(linear==1))*1000;
std_Unit_Slope = std(RR_Mins_Unit_Slope(unit_slope==1))*1000;
std_CARA       = std(RR_Mins_CARA(cara==1))*1000;


median_Monotone   = quantile(RR_Mins_Monotone(monotone==1),.5)*1000;
median_Quad       = quantile(RR_Mins_Quadratic(quadratic==1),.5)*1000;
median_Linear     = quantile(RR_Mins_Linear(linear==1),.5)*1000;
median_Unit_Slope = quantile(RR_Mins_Unit_Slope(unit_slope==1),.5)*1000;
median_CARA       = quantile(RR_Mins_CARA(cara==1),.5)*1000;

subplot 321
bar(RR_plotter*1000,hist_Monotone/sum(hist_Monotone),'b','linewidth',1,'edgecolor','b')
title('Monotonicity')
axis('tight')
ylim([0 1])
subplot 322
bar(RR_plotter*1000,hist_Quad/sum(hist_Quad),'b','linewidth',1,'edgecolor','b')
title('Quadraticity')
axis('tight')
ylim([0 1])

subplot 323
bar(RR_plotter*1000,hist_Linear/sum(hist_Linear),'b','linewidth',1,'edgecolor','b')
title('Linearity')
axis('tight')
ylim([0 1])

subplot 324
bar(RR_plotter*1000,hist_Unit_Slope/sum(hist_Unit_Slope),'b','linewidth',1,'edgecolor','b')
title('Unit slope')
axis('tight')
ylim([0 1])

xlabel('r_i x 10^-^3')

subplot 325
bar(RR_plotter*1000,hist_CARA/sum(hist_CARA),'b','linewidth',1,'edgecolor','b')
title('Zero intercept')
axis('tight')
ylim([0 1])

xlabel('r_i x 10^-^3')


                                                                    text(1.6*max(RR_plotter*1000),.90,'Median  ','fontsize',8); text(1.75*max(RR_plotter*1000),.90,'   Mean','fontsize',8); text(1.9*max(RR_plotter*1000),.90,'   Std. dev.     x 10 ^-^3','fontsize',8)
text(1.25*max(RR_plotter*1000),.75, 'Monotonicity','fontsize',8) ;  text(1.6*max(RR_plotter*1000),.75,['  ' num2str(mean_Monotone,2)     '       ' num2str(mean_Monotone,2)   '       ' num2str(std_Monotone,2)],'fontsize',8)
text(1.25*max(RR_plotter*1000),.60, 'Quadraticity','fontsize',8)  ; text(1.6*max(RR_plotter*1000),.60,['  ' num2str(median_Quad,2)       '       ' num2str(mean_Quad,2)       '       '  num2str(std_Quad,2)],'fontsize',8)
text(1.25*max(RR_plotter*1000),.45, 'Linearity','fontsize',8)     ; text(1.6*max(RR_plotter*1000),.45,['  ' num2str(median_Linear,2)     '       ' num2str(mean_Linear,2)     '       '  num2str(std_Linear,2) ],'fontsize',8)
text(1.25*max(RR_plotter*1000),.30, 'Unit slope','fontsize',8)    ; text(1.6*max(RR_plotter*1000),.30,['  ' num2str(median_Unit_Slope,2) '       ' num2str(mean_Unit_Slope,3) '       '  num2str(std_Unit_Slope,2)  ] ,'fontsize',8)
text(1.25*max(RR_plotter*1000),.15, 'Zero intercept','fontsize',8); text(1.6*max(RR_plotter*1000),.15,['  ' num2str(median_CARA,2)       '       ' num2str(mean_CARA,2)       '       '  num2str(std_CARA,2)],'fontsize',8)


print -depsc2 Figure_1_750

temp_0= zeros(1,length(RR_vec));
temp_1= zeros(1,length(RR_vec));
temp_2= zeros(1,length(RR_vec));
temp_3= zeros(1,length(RR_vec));
temp_4= zeros(1,length(RR_vec));
temp_5= zeros(1,length(RR_vec));

for jj=1:length(RR_vec);
    temp_0(jj)= sum((sum(PLAUSIBILITY(:,1:jj),2)>0));
    temp_1(jj)= sum((sum(MONOTONICITY(:,1:jj),2)>0));
    temp_2(jj)= sum((sum(QUADRATIC(:,1:jj),2)>0));
    temp_3(jj)= sum((sum(LINEAR(:,1:jj),2)>0));
    temp_4(jj)= sum((sum(UNIT_SLOPE(:,1:jj),2)>0));
    temp_5(jj)= sum((sum(CARA(:,1:jj),2)>0));
end


figure
    
    
plot(RR_vec,temp_1/Num_Obs*100,'b--','linewidth',2,'markersize',7)
hold on
plot(RR_vec,temp_2/Num_Obs*100,'k-+','linewidth',2,'markersize',4)
plot(RR_vec,temp_3/Num_Obs*100,'m-.','linewidth',2,'markersize',7)
plot(RR_vec,temp_4/Num_Obs*100,'g','linewidth',2,'markersize',7)
plot(RR_vec,temp_5/Num_Obs*100,'ro','linewidth',2,'markersize',2)


xlabel('Upper bound on r_i')
ylabel('Percent of rationalizable households')
ylim([0 100])
xlim([0 r_max*1e-3])
legend('Monotonicity','Quadraticity','Linearity','Unit slope','Zero intercept','location','southeast')
legend boxoff


print -depsc2 Figure_2_750