path(path,'c:\mydocuments\insurance_4_stability\data')
clear all
close all
BtS = 100;


take_two_hundred_out              =   0;

load_data


r_step                =   .1;

r_max                 =   10.8;

RR_vec                =  [(r_max:-r_step:1+r_step)*1e-3 (10:-1:1)*1e-4 (10:-1:1)*1e-5 (10:-1:1)*1e-6 0];
RR_vec                =  unique(RR_vec);

LOWER_BAR            =  0;
UPPER_BAR            =  1;

Total_Num_Obs        =  length(lambda_comp);

PLAUSIBILITY         =  zeros(length(RR_vec),Total_Num_Obs);

parfor kk=1:length(RR_vec)
    RR= RR_vec(kk);
    [~,~,~,Plausibility] = test_04_06_15(lambda_comp,lambda_coll,lambda_home,pp_comp,pp_coll,pp_home,comp_prem,coll_prem,home_prem,deduc_list_comp,deduc_list_coll,deduc_list_home,...
        comp_deduc,coll_deduc,home_deduc,repmat(RR,Total_Num_Obs,1),LOWER_BAR,UPPER_BAR,Total_Num_Obs);
    
    PLAUSIBILITY(kk,:) = Plausibility;
end


plausible_sample =  find(sum(PLAUSIBILITY)>0);

lambda_comp      =  lambda_comp(plausible_sample,:);
lambda_coll      =  lambda_coll(plausible_sample,:);
lambda_home      =  lambda_home(plausible_sample,:);
pp_comp          =  pp_comp(plausible_sample,:);
pp_coll          =  pp_coll(plausible_sample,:);
pp_home          =  pp_home(plausible_sample,:);
comp_prem        =  comp_prem(plausible_sample,:);
coll_prem        =  coll_prem(plausible_sample,:);
home_prem        =  home_prem(plausible_sample,:);
comp_deduc       =  comp_deduc(plausible_sample,:);
coll_deduc       =  coll_deduc(plausible_sample,:);
home_deduc       =  home_deduc(plausible_sample,:);
gamm_1coll       =  gamm_1coll(plausible_sample,:);
gamm_2coll       =  gamm_2coll(plausible_sample,:);
gamm_1comp       =  gamm_1comp(plausible_sample,:);
gamm_2comp       =  gamm_2comp(plausible_sample,:);
gamm_1home       =  gamm_1home(plausible_sample,:);
gamm_2home       =  gamm_2home(plausible_sample,:);

Num_Obs          =  length(lambda_comp);




monotone_BtS   = zeros(1,BtS);
quadratic_BtS  = zeros(1,BtS);
linear_BtS     = zeros(1,BtS);
unit_slope_BtS = zeros(1,BtS);
cara_BtS       = zeros(1,BtS);
for bts= 1:BtS
    tic
    disp(bts)
    rng(123456789+bts*222) % run half with 222, half with 111
    
    shock_coll   =   gamrnd(gamm_1coll,gamm_2coll)./gamm_1coll./gamm_2coll;
    shock_comp   =   gamrnd(gamm_1comp,gamm_2comp)./gamm_1comp./gamm_2comp;
    shock_home   =   gamrnd(gamm_1home,gamm_2home)./gamm_1home./gamm_2home;
    
    
    lambda_comp_bts          =   1- exp(-lambda_comp.*shock_comp);
    lambda_coll_bts          =   1- exp(-lambda_coll.*shock_coll);
    lambda_home_bts          =   1- exp(-lambda_home.*shock_home);
    
    
    
    Q_EXITFLAG_min = zeros(length(RR_vec),Num_Obs,3);
    Q_EXITFLAG_max = zeros(length(RR_vec),Num_Obs,3);
    Q_Omega_min_out= zeros(length(RR_vec),Num_Obs,3);
    Q_Omega_max_out= zeros(length(RR_vec),Num_Obs,3);
    PLAUSIBILITY   = zeros(length(RR_vec),Num_Obs);
    MONOTONICITY   = zeros(length(RR_vec),Num_Obs);
    QUADRATICITY   = zeros(length(RR_vec),Num_Obs);
    LINEAR         = zeros(length(RR_vec),Num_Obs);
    UNIT_SLOPE     = zeros(length(RR_vec),Num_Obs);
    CARA           = zeros(length(RR_vec),Num_Obs);
    
    for kk=1
        disp(kk)
        RR= RR_vec(kk);
        [LBS,UBS,lambdas,Plausibility,Monotonicity] = test_04_06_15(lambda_comp_bts,lambda_coll_bts,lambda_home_bts,pp_comp,pp_coll,pp_home,comp_prem,coll_prem,home_prem,deduc_list_comp,deduc_list_coll,deduc_list_home,...
            comp_deduc,coll_deduc,home_deduc,repmat(RR,Num_Obs,1),LOWER_BAR,UPPER_BAR,Num_Obs);
        
        LBS_b_eq_1      =   LBS-lambdas;
        UBS_b_eq_1      =   UBS-lambdas;
        
        LBS_b_eq_1      =   max(LBS_b_eq_1,[],2);
        UBS_b_eq_1      =   min(UBS_b_eq_1,[],2);
        
        UB_1_vec =     UBS(:,1);
        LB_1_vec =     LBS(:,1);
        mu_1_vec = lambdas(:,1);
        
        UB_2_vec =     UBS(:,2);
        LB_2_vec =     LBS(:,2);
        mu_2_vec = lambdas(:,2);
        
        UB_3_vec =     UBS(:,3);
        LB_3_vec =     LBS(:,3);
        mu_3_vec = lambdas(:,3);
        
        selector = Monotonicity;
        
        length_vec = find_vertices(UB_1_vec,LB_1_vec,UB_2_vec,LB_2_vec,UB_3_vec,LB_3_vec,mu_1_vec,mu_2_vec,mu_3_vec,10,1);
        
        LINEAR(kk,:)=(length_vec.*Monotonicity)>0;
        for jj =1:3
            parfor ii=1:length(lambdas)
                
                if selector(ii)==1 %#ok<*PFBNS> %
                    [~,temp,temp_two] = linprog([1; lambdas(ii,jj);lambdas(ii,jj)^2], [1  mu_1_vec(ii)  mu_1_vec(ii)^2; 1   mu_2_vec(ii)  mu_2_vec(ii)^2 ; 1  mu_3_vec(ii)  mu_3_vec(ii)^2;...
                        -1 -mu_1_vec(ii) -mu_1_vec(ii)^2; -1 -mu_2_vec(ii) -mu_2_vec(ii)^2; -1 -mu_3_vec(ii) -mu_3_vec(ii)^2;...
                        0  -1 -2*lambdas(ii,jj)],...
                        [  UB_1_vec(ii);   UB_2_vec(ii);   UB_3_vec(ii);    -LB_1_vec(ii);   - LB_2_vec(ii);    -LB_3_vec(ii); 0],[],[],...
                        [-100000; 0; -100], [1;200000;200000],[0;1;0],optimset('Display','off', 'TolFun',1e-8));
                    if temp_two==1
                        Q_Omega_min_out(kk,ii,jj)= temp;
                    end
                    Q_EXITFLAG_min(kk,ii,jj)=  temp_two;
                    
                    [~,temp,temp_two] = linprog([-1; -lambdas(ii,jj);-lambdas(ii,jj)^2],[1  mu_1_vec(ii)  mu_1_vec(ii)^2; 1   mu_2_vec(ii)  mu_2_vec(ii)^2 ; 1  mu_3_vec(ii)  mu_3_vec(ii)^2;...
                        -1 -mu_1_vec(ii) -mu_1_vec(ii)^2; -1 -mu_2_vec(ii) -mu_2_vec(ii)^2; -1 -mu_3_vec(ii) -mu_3_vec(ii)^2;...
                        0  -1 -2*lambdas(ii,jj)],...
                        [  UB_1_vec(ii);   UB_2_vec(ii);   UB_3_vec(ii);    -LB_1_vec(ii);   - LB_2_vec(ii);    -LB_3_vec(ii); 0],[],[],...
                        [-100000; 0; -100], [1;200000;200000],[0;1;0],optimset('Display','off', 'TolFun',1e-8));
                    
                    if temp_two==1
                        Q_Omega_max_out(kk,ii,jj)= -temp;
                    end
                    Q_EXITFLAG_max(kk,ii,jj)= temp_two;
                end
            end
        end
        
        temp      = sum(Q_EXITFLAG_max(kk,:,:)+Q_EXITFLAG_min(kk,:,:)==2,3);
        
        PLAUSIBILITY(kk,:) = Plausibility;
        QUADRATICITY(kk,:) = temp==3;
        MONOTONICITY(kk,:) = Monotonicity;
        UNIT_SLOPE(kk,:)   = UBS_b_eq_1>=LBS_b_eq_1+1e-8;
        CARA(kk,:)         = sum((UBS>=lambdas).*(LBS<=lambdas),2);

    end
    for kk=2:length(RR_vec)
            disp(kk)
    
        RR= RR_vec(kk);
        [LBS,UBS,lambdas,Plausibility,Monotonicity] = test_04_06_15(lambda_comp_bts,lambda_coll_bts,lambda_home_bts,pp_comp,pp_coll,pp_home,comp_prem,coll_prem,home_prem,deduc_list_comp,deduc_list_coll,deduc_list_home,...
            comp_deduc,coll_deduc,home_deduc,repmat(RR,Num_Obs,1),LOWER_BAR,UPPER_BAR,Num_Obs);
        
        
        LBS_b_eq_1      =   LBS-lambdas;
        UBS_b_eq_1      =   UBS-lambdas;
        
        LBS_b_eq_1      =   max(LBS_b_eq_1,[],2);
        UBS_b_eq_1      =   min(UBS_b_eq_1,[],2);
        
        UB_1_vec =     UBS(:,1);
        LB_1_vec =     LBS(:,1);
        mu_1_vec = lambdas(:,1);
        
        UB_2_vec =     UBS(:,2);
        LB_2_vec =     LBS(:,2);
        mu_2_vec = lambdas(:,2);
        
        UB_3_vec =     UBS(:,3);
        LB_3_vec =     LBS(:,3);
        mu_3_vec = lambdas(:,3);
        
        quad_temp =  sum(QUADRATICITY(1:kk,:));
        selector  = Monotonicity.*(1-quad_temp)';
        
        length_vec = find_vertices(UB_1_vec,LB_1_vec,UB_2_vec,LB_2_vec,UB_3_vec,LB_3_vec,mu_1_vec,mu_2_vec,mu_3_vec,10,1);
        
        LINEAR(kk,:)=(length_vec.*Monotonicity)>0;
        
        for jj =1:3
            parfor ii=1:length(lambdas)
                
                if selector(ii)==1
                    [~,temp,temp_two] = linprog([1; lambdas(ii,jj);lambdas(ii,jj)^2], [1  mu_1_vec(ii)  mu_1_vec(ii)^2; 1   mu_2_vec(ii)  mu_2_vec(ii)^2 ; 1  mu_3_vec(ii)  mu_3_vec(ii)^2;...
                        -1 -mu_1_vec(ii) -mu_1_vec(ii)^2; -1 -mu_2_vec(ii) -mu_2_vec(ii)^2; -1 -mu_3_vec(ii) -mu_3_vec(ii)^2;...
                        0  -1 -2*lambdas(ii,jj)],...
                        [  UB_1_vec(ii);   UB_2_vec(ii);   UB_3_vec(ii);    -LB_1_vec(ii);   - LB_2_vec(ii);    -LB_3_vec(ii); 0],[],[],...
                        [-100000; 0; -100], [1;200000;200000],[0;1;0],optimset('Display','off', 'TolFun',1e-8));
                    if temp_two==1
                        Q_Omega_min_out(kk,ii,jj)= temp;
                    end
                    Q_EXITFLAG_min(kk,ii,jj)=  temp_two;
                    
                    [~,temp,temp_two] = linprog([-1; -lambdas(ii,jj);-lambdas(ii,jj)^2],[1  mu_1_vec(ii)  mu_1_vec(ii)^2; 1   mu_2_vec(ii)  mu_2_vec(ii)^2 ; 1  mu_3_vec(ii)  mu_3_vec(ii)^2;...
                        -1 -mu_1_vec(ii) -mu_1_vec(ii)^2; -1 -mu_2_vec(ii) -mu_2_vec(ii)^2; -1 -mu_3_vec(ii) -mu_3_vec(ii)^2;...
                        0  -1 -2*lambdas(ii,jj)],...
                        [  UB_1_vec(ii);   UB_2_vec(ii);   UB_3_vec(ii);    -LB_1_vec(ii);   - LB_2_vec(ii);    -LB_3_vec(ii); 0],[],[],...
                        [-100000; 0; -100], [1;200000;200000],[0;1;0],optimset('Display','off', 'TolFun',1e-8));
                    
                    if temp_two==1
                        Q_Omega_max_out(kk,ii,jj)= -temp;
                    end
                    Q_EXITFLAG_max(kk,ii,jj)= temp_two;
                end
            end
        end
        PLAUSIBILITY(kk,:) = Plausibility;
        MONOTONICITY(kk,:) = Monotonicity;
        UNIT_SLOPE(kk,:)   = UBS_b_eq_1>=LBS_b_eq_1+1e-8;
        CARA(kk,:)         = sum((UBS>=lambdas).*(LBS<=lambdas),2);
       
    end
    
    UNIT_SLOPE  =   UNIT_SLOPE.*MONOTONICITY.*PLAUSIBILITY;
    temp      = sum(Q_EXITFLAG_max+Q_EXITFLAG_min==2,3);
    QUADRATIC = temp==3;
    CARA      = CARA==3;
    
    PLAUSIBILITY    =   PLAUSIBILITY';
    MONOTONICITY    =   MONOTONICITY';
    LINEAR          =   LINEAR';
    QUADRATIC       =   QUADRATIC';
    UNIT_SLOPE      =   UNIT_SLOPE';
    CARA            =   CARA';

    
    plausible    =  sum(PLAUSIBILITY==1,2)>0;
    monotone     =  sum(MONOTONICITY==1,2)>0;
    linear       =  sum(LINEAR   ==1,2)>0;
    quadratic    =  sum(QUADRATIC==1,2)>0;
    unit_slope   =  sum(UNIT_SLOPE==1,2)>0;
    cara         =  sum(CARA==1,2)>0;

    monotone_BtS(bts)  = sum(monotone);
    quadratic_BtS(bts) = sum(quadratic);
    linear_BtS(bts)    = sum(linear);
    unit_slope_BtS(bts)= sum(unit_slope);
    cara_BtS(bts)      = sum(cara);
    toc
end

monotone_stats     = quantile(monotone_BtS,[.05 .10 .25 .5 .75 .9 .95]);
quadratic_stats    = quantile(quadratic_BtS,[.05 .10 .25 .5 .75 .9 .95]);
linear_stats       = quantile(linear_BtS,[.05 .10 .25 .5 .75 .9 .95]);
unit_slope_stats   = quantile(unit_slope_BtS,[.05 .10 .25 .5 .75 .9 .95]);
cara_stats         = quantile(cara_BtS,[.05 .10 .25 .5 .75 .9 .95]);

disp(monotone_stats/Num_Obs)
disp(quadratic_stats/Num_Obs)
disp(linear_stats/Num_Obs)
disp(unit_slope_stats/Num_Obs)
disp(cara_stats/Num_Obs)


home_machine_run = [ monotone_BtS
                     quadratic_BtS
                     linear_BtS
                     unit_slope_BtS
                     cara_BtS];
%save home_machine_run home_machine_run
%save office_machine_run office_machine_run
% load office_machine_run 
% load home_machine_run
% total_run = [home_machine_run office_machine_run];
% 
% disp(quantile(total_run,[.05 .25 .5 .75 .95],2)/Num_Obs)