clear all
close all
take_two_hundred_out              =   0;

load_data

lambda_comp          =   1- exp(-lambda_comp);
lambda_coll          =   1- exp(-lambda_coll);
lambda_home          =   1- exp(-lambda_home);

r_step                =   .1;

r_max                 =   10.8;%20;

RR_vec                =  [(r_max:-r_step:1+r_step)*1e-3 (10:-1:1)*1e-4 (10:-1:1)*1e-5 (10:-1:1)*1e-6 0];
RR_vec                =  unique(RR_vec);

LOWER_BAR            =  0;
UPPER_BAR            =  1;

Total_Num_Obs        =  length(lambda_comp);

PLAUSIBILITY         =  zeros(length(RR_vec),Total_Num_Obs);

parfor kk=1:length(RR_vec)
    tic
    RR= RR_vec(kk);
    [~,~,~,Plausibility] = test_04_06_15(lambda_comp,lambda_coll,lambda_home,pp_comp,pp_coll,pp_home,comp_prem,coll_prem,home_prem,deduc_list_comp,deduc_list_coll,deduc_list_home,...
        comp_deduc,coll_deduc,home_deduc,repmat(RR,Total_Num_Obs,1),LOWER_BAR,UPPER_BAR,Total_Num_Obs);
   
    PLAUSIBILITY(kk,:) = Plausibility;
end


plausible_sample =  find(sum(PLAUSIBILITY)>0);

lambda_comp      =  lambda_comp(plausible_sample,:);
lambda_coll      =  lambda_coll(plausible_sample,:);
lambda_home      =  lambda_home(plausible_sample,:);
pp_comp          =  pp_comp(plausible_sample,:);
pp_coll          =  pp_coll(plausible_sample,:);
pp_home          =  pp_home(plausible_sample,:);
comp_prem        =  comp_prem(plausible_sample,:);
coll_prem        =  coll_prem(plausible_sample,:);
home_prem        =  home_prem(plausible_sample,:);
comp_deduc       =  comp_deduc(plausible_sample,:);
coll_deduc       =  coll_deduc(plausible_sample,:);
home_deduc       =  home_deduc(plausible_sample,:);

Num_Obs          =  length(lambda_comp);

rng(123456)

BtS = 200;

plausible       =   zeros(1,BtS);
monotonicity    =   zeros(1,BtS);
linear          =   zeros(1,BtS);
unit_slope      =   zeros(1,BtS);
kr              =   zeros(1,BtS);
gd              =   zeros(1,BtS);
cara            =   zeros(1,BtS);


for bts=1:BtS
    comp_prem_bts = zeros(Num_Obs,1);
    coll_prem_bts = zeros(Num_Obs,1);
    home_prem_bts = zeros(Num_Obs,1);
    
    temp               =randperm(Num_Obs);
    comp_deduc_bts     = comp_deduc(temp);
    for ii=1:Num_Obs
    comp_prem_bts(ii)= pp_comp(ii,comp_deduc_bts(ii)==deduc_list_comp);
    end
    
    temp               =randperm(Num_Obs);
    coll_deduc_bts     = coll_deduc(temp);
    for ii=1:Num_Obs
    coll_prem_bts(ii)= pp_coll(ii,coll_deduc_bts(ii)==deduc_list_coll);
    end
    
    temp               =randperm(Num_Obs);
    home_deduc_bts     = home_deduc(temp);
    for ii=1:Num_Obs
    home_prem_bts(ii)= pp_home(ii,home_deduc_bts(ii)==deduc_list_home);
    end
    
    PLAUSIBILITY   = zeros(length(RR_vec),Num_Obs);
    MONOTONICITY   = zeros(length(RR_vec),Num_Obs);
    LINEAR         = zeros(length(RR_vec),Num_Obs);
    UNIT_SLOPE     = zeros(length(RR_vec),Num_Obs);
    KR             = zeros(length(RR_vec),Num_Obs);
    GD             = zeros(length(RR_vec),Num_Obs);
    CARA           = zeros(length(RR_vec),Num_Obs);
    tic
    parfor kk=1:length(RR_vec)
        RR= RR_vec(kk);
        [LBS,UBS,lambdas,Plausibility,Monotonicity] = test_04_06_15(lambda_comp,lambda_coll,lambda_home,pp_comp,pp_coll,pp_home,comp_prem_bts,coll_prem_bts,home_prem_bts,deduc_list_comp,deduc_list_coll,deduc_list_home,...
            comp_deduc_bts,coll_deduc_bts,home_deduc_bts,repmat(RR,Num_Obs,1),LOWER_BAR,UPPER_BAR,Num_Obs);
        
        
        LBS_KR      =   (LBS-lambdas)./(1-lambdas)./lambdas;
        UBS_KR      =   (UBS-lambdas)./(1-lambdas)./lambdas;
        
        LBS_KR      =   max(LBS_KR,[],2);
        UBS_KR      =   min(UBS_KR,[],2);
        
        KR(kk,:)    =   (UBS_KR>=LBS_KR-1e-8).*(UBS_KR>=0);
        
        LBS_GD      =   (LBS-lambdas)./(LBS.*(1-lambdas));
        UBS_GD      =   (UBS-lambdas)./(UBS.*(1-lambdas));
        
        LBS_GD      =   max(LBS_GD,[],2);
        UBS_GD      =   min(UBS_GD,[],2);
        
        GD(kk,:)    =   (UBS_GD>=LBS_GD-1e-8).*(UBS_GD>=0);
        CARA(kk,:)  =   prod((UBS>=lambdas).*(LBS<=lambdas),2);
        LBS_b_eq_1      =   LBS-lambdas;
        UBS_b_eq_1      =   UBS-lambdas;
        
        LBS_b_eq_1      =   max(LBS_b_eq_1,[],2);
        UBS_b_eq_1      =   min(UBS_b_eq_1,[],2);
        
        UB_1_vec =     UBS(:,1);
        LB_1_vec =     LBS(:,1);
        mu_1_vec = lambdas(:,1);
        
        UB_2_vec =     UBS(:,2);
        LB_2_vec =     LBS(:,2);
        mu_2_vec = lambdas(:,2);
        
        UB_3_vec =     UBS(:,3);
        LB_3_vec =     LBS(:,3);
        mu_3_vec = lambdas(:,3);
        selector = Monotonicity;
        
        PLAUSIBILITY(kk,:) = Plausibility;
        MONOTONICITY(kk,:) = Monotonicity;
        UNIT_SLOPE(kk,:)   = (UBS_b_eq_1>=LBS_b_eq_1-1e-8).*(UBS_b_eq_1>0).*(LBS_b_eq_1<1);
    end
    toc
    MONOTONICITY =  MONOTONICITY.*PLAUSIBILITY;
    KR          =   KR  .*MONOTONICITY;
    GD          =   GD  .*MONOTONICITY;
    CARA        =   CARA.*MONOTONICITY;
    UNIT_SLOPE  =   UNIT_SLOPE  .*MONOTONICITY;
    LINEAR      =   LINEAR.*MONOTONICITY;
    
    plausible(bts)   =   mean(sum(PLAUSIBILITY'==1,2)>0);
    monotonicity(bts)=   mean(sum(MONOTONICITY'==1,2)>0);
    linear(bts)      =   mean(sum(LINEAR'==1,2)>0);
    unit_slope(bts)  =   mean(sum(UNIT_SLOPE'==1,2)>0);
    kr(bts)          =   mean(sum(KR'==1,2)>0);
    gd(bts)          =   mean(sum(GD'==1,2)>0);
    cara(bts)        =   mean(sum(CARA'==1,2)>0);
end

disp(['plausible   ' num2str(mean(plausible),4)])
disp(['monotone    ' num2str(mean(monotonicity),4)])
disp(['unit_slope  ' num2str(mean(unit_slope),4)])
disp(['kr          ' num2str(mean(kr),4)])
disp(['gd          ' num2str(mean(gd),4)])
disp(['cara        ' num2str(mean(cara),4)])


disp(['plausible   ' num2str(quantile(plausible,[.025 .975]),4)])
disp(['monotone    ' num2str(quantile(monotonicity,[.025 .975]),4)])
disp(['unit_slope  ' num2str(quantile(unit_slope,[.025 .975]),4)])
disp(['kr          ' num2str(quantile(kr,[.025 .975]),4)])
disp(['gd          ' num2str(quantile(gd,[.025 .975]),4)])
disp(['cara        ' num2str(quantile(cara,[.025 .975]),4)])

