clear all
close all

load  tested_05_28_15

b_optimal = .0095;

lambdas_grid = linspace(.001,.16,50);
%%


[LBS,UBS]  = test_04_06_15(lambda_comp,lambda_coll,lambda_home,pp_comp,pp_coll,pp_home,comp_prem,coll_prem,home_prem,deduc_list_comp,deduc_list_coll,deduc_list_home,...
        comp_deduc,coll_deduc,home_deduc,RR_Mins_Monotone,LOWER_BAR,UPPER_BAR,Num_Obs);


r_u=ksr(reshape(lambdas(monotone==1,:),[],1),reshape(UBS(monotone==1,:),[],1),b_optimal,length(lambdas_grid),lambdas_grid);
r_l=ksr(reshape(lambdas(monotone==1,:),[],1),reshape(LBS(monotone==1,:),[],1),b_optimal,length(lambdas_grid),lambdas_grid);


r_u_monotone = r_u.f;
r_l_monotone = r_l.f;
r_lambda_grid= lambdas_grid;
figure

fill([0 0 r_lambda_grid r_lambda_grid(end)],[ 0 r_u_monotone(1) r_u_monotone 0],[.85 .85 .85])
hold on

alpha =  .40;
KT_1    = r_lambda_grid.^alpha./(r_lambda_grid.^alpha+(1-r_lambda_grid).^alpha).^(1/alpha);

alpha =  .55;
KT_2    = r_lambda_grid.^alpha./(r_lambda_grid.^alpha+(1-r_lambda_grid).^alpha).^(1/alpha);

alpha =  .69;
KT_3    = r_lambda_grid.^alpha./(r_lambda_grid.^alpha+(1-r_lambda_grid).^alpha).^(1/alpha);
plot(r_lambda_grid,KT_1, 'b--','linewidth',2)
plot(r_lambda_grid,KT_2, 'k-.','linewidth',2)
plot(r_lambda_grid,KT_3, 'r','linewidth',2)
plot(r_lambda_grid,r_lambda_grid, 'k--','linewidth',.5)

legend('\Omega-intervals','Tversky-Kahneman PWF, \gamma = 0.40' ,'Tversky-Kahneman PWF, \gamma = 0.55', 'Tversky-Kahneman PWF, \gamma = 0.69' ,'45 degree line', 'location','northwest')
legend boxoff
fill([0 0 r_lambda_grid r_lambda_grid(end)],[ 0 r_l_monotone(1) r_l_monotone 0 ],[1 1 1])

plot(r_lambda_grid,KT_1, 'b--','linewidth',2)
plot(r_lambda_grid,KT_2, 'k-.','linewidth',2)
plot(r_lambda_grid,KT_3, 'r','linewidth',2)
plot(r_lambda_grid,r_lambda_grid, 'k--','linewidth',.5)
xlabel('\mu')

xlim([0 .16])
ylim([0 .4])

print -depsc2 Figure_4A

figure

fill([0 0 r_lambda_grid r_lambda_grid(end)],[ 0 r_u_monotone(1) r_u_monotone 0],[.85 .85 .85])
hold on

omega  = .4;
Prelec_1      = exp(-(-log(r_lambda_grid)).^omega);

omega  = .55;
Prelec_2      = exp(-(-log(r_lambda_grid)).^omega);

omega  = .69;
Prelec_3      = exp(-(-log(r_lambda_grid)).^omega);

plot(r_lambda_grid,Prelec_1, 'b--','linewidth',2)
plot(r_lambda_grid,Prelec_2, 'k-.','linewidth',2)
plot(r_lambda_grid,Prelec_3, 'r','linewidth',2)
plot(r_lambda_grid,r_lambda_grid, 'k--','linewidth',.5)

legend('\Omega-intervals','Prelec PWF, \gamma = 0.40' ,'Prelec PWF, \gamma = 0.55', 'Prelec PWF, \gamma = 0.69' ,'45 degree line', 'location','northwest')
legend boxoff
fill([0 0 r_lambda_grid r_lambda_grid(end)],[ 0 r_l_monotone(1) r_l_monotone 0 ],[1 1 1])

plot(r_lambda_grid,Prelec_1, 'b--','linewidth',2)
plot(r_lambda_grid,Prelec_2, 'k-.','linewidth',2)
plot(r_lambda_grid,Prelec_3, 'r','linewidth',2)
plot(r_lambda_grid,r_lambda_grid, 'k--','linewidth',.5)
xlabel('\mu')

xlim([0 .16])
ylim([0 .4])

print -depsc2 Figure_4B
