function [LBS,UBS,lambdas,Plausibility,Monotonicity,LBSraw,UBSraw,index]=...
    test_04_06_15_ntd(lambda_comp,lambda_coll,lambda_home,...
    pp_comp,                pp_coll,        pp_home,...
    comp_prem,            coll_prem,      home_prem,...
    deduc_list_comp,deduc_list_coll,deduc_list_home,...
    comp_deduc,          coll_deduc,      home_deduc,...
    RR_vec,LOWER_BAR,UPPER_BAR,Num_Obs)


[lambdas,index]     =   sort([lambda_comp lambda_coll lambda_home],2);

delta_pp_comp     =  pp_comp- repmat(comp_prem,1,length(deduc_list_comp));
delta_pp_coll     =  pp_coll- repmat(coll_prem,1,length(deduc_list_coll));
delta_pp_home     =  pp_home- repmat(home_prem,1,length(deduc_list_home));

delta_deduc_comp     =  repmat(deduc_list_comp,Num_Obs,1)- repmat(comp_deduc,1,length(deduc_list_comp));
delta_deduc_coll     =  repmat(deduc_list_coll,Num_Obs,1)- repmat(coll_deduc,1,length(deduc_list_coll));
delta_deduc_home     =  repmat(deduc_list_home,Num_Obs,1)- repmat(home_deduc,1,length(deduc_list_home));

delta_comp_price_squared   =   pp_comp.^2- repmat(comp_prem.^2,1,length(deduc_list_comp));
delta_coll_price_squared   =   pp_coll.^2- repmat(coll_prem.^2,1,length(deduc_list_coll));
delta_home_price_squared   =   pp_home.^2- repmat(home_prem.^2,1,length(deduc_list_home));

delta_comp_price_deduc_squared   = (pp_comp + repmat(deduc_list_comp,Num_Obs,1)).^2- repmat((comp_prem+comp_deduc).^2,1,length(deduc_list_comp));
delta_coll_price_deduc_squared   = (pp_coll + repmat(deduc_list_coll,Num_Obs,1)).^2- repmat((coll_prem+coll_deduc).^2,1,length(deduc_list_coll));
delta_home_price_deduc_squared   = (pp_home + repmat(deduc_list_home,Num_Obs,1)).^2- repmat((home_prem+home_deduc).^2,1,length(deduc_list_home));


LB_comp              =  zeros(Num_Obs,1);
UB_comp              =  zeros(Num_Obs,1);
LB_coll              =  zeros(Num_Obs,1);
UB_coll              =  zeros(Num_Obs,1);
LB_home              =  zeros(Num_Obs,1);
UB_home              =  zeros(Num_Obs,1);

RR                   =   RR_vec;

Bounds_comp          =  -(delta_pp_comp+repmat(RR/2,1,length(deduc_list_comp)).*delta_comp_price_squared)./(delta_deduc_comp+repmat(RR/2,1,length(deduc_list_comp)).*(delta_comp_price_deduc_squared-delta_comp_price_squared ));
Bounds_coll          =  -(delta_pp_coll+repmat(RR/2,1,length(deduc_list_coll)).*delta_coll_price_squared)./(delta_deduc_coll+repmat(RR/2,1,length(deduc_list_coll)).*(delta_coll_price_deduc_squared-delta_coll_price_squared ));
Bounds_home          =  -(delta_pp_home+repmat(RR/2,1,length(deduc_list_home)).*delta_home_price_squared)./(delta_deduc_home+repmat(RR/2,1,length(deduc_list_home)).*(delta_home_price_deduc_squared-delta_home_price_squared ));


% numerator is always of the right sign
% the question is the denumerator- 

for ii=1:Num_Obs
    if comp_deduc(ii)~=deduc_list_comp(1)
        temp            =  Bounds_comp(ii,comp_deduc(ii)>deduc_list_comp & Bounds_comp(ii,:)>0);
        if isempty(temp)
            UB_comp(ii)=1;
        else
        UB_comp(ii)     =   min(temp);
        end
    else
        UB_comp(ii)     =   UPPER_BAR;
    end
    if comp_deduc(ii)~=deduc_list_comp(end)        
        LB_comp(ii)     =   max(Bounds_comp(ii,comp_deduc(ii)<deduc_list_comp));
    else
        LB_comp(ii)     =   LOWER_BAR;
    end
       
    if coll_deduc(ii)~=deduc_list_coll(1)
        temp            =  Bounds_coll(ii,coll_deduc(ii)>deduc_list_coll & Bounds_coll(ii,:)>0);
        if isempty(temp)
        UB_coll(ii)=1;
        else
        UB_coll(ii)     =   min(temp);
        end
    else
        UB_coll(ii)     =   UPPER_BAR;
    end
    if coll_deduc(ii)~=deduc_list_coll(end)
        LB_coll(ii)     =   max(Bounds_coll(ii,coll_deduc(ii)<deduc_list_coll));
    else
        LB_coll(ii)     =  LOWER_BAR;
    end
    
    
    if home_deduc(ii)~=deduc_list_home(1)
        temp            =  Bounds_home(ii,home_deduc(ii)>deduc_list_home & Bounds_home(ii,:)>0);
        if isempty(temp)
            UB_home(ii)=1;
        else
        UB_home(ii)     =   min(temp);
        end
    else
        UB_home(ii)     =   UPPER_BAR;
    end
    if home_deduc(ii)~=deduc_list_home(end)
        LB_home(ii)     =   max(Bounds_home(ii,home_deduc(ii)<deduc_list_home));
    else
        LB_home(ii)     =   LOWER_BAR;
    end
end
LBS                 =   [LB_comp LB_coll LB_home];
LBS                 =    max(LBS,LOWER_BAR);

UBS                 =   [UB_comp UB_coll UB_home];
UBS                 =    min(UBS,UPPER_BAR);

for ii=1:length(LB_coll)
    LBS(ii,:)                 =   LBS(ii,index(ii,:));
    UBS(ii,:)                 =   UBS(ii,index(ii,:));
end
cond_001=max(LBS,[],2)>UPPER_BAR;
cond_002=min(UBS,[],2)<LOWER_BAR;


cond_01=LBS(:,1)>=UBS(:,1)+1e-8;
cond_02=LBS(:,2)>=UBS(:,2)+1e-8;
cond_03=LBS(:,3)>=UBS(:,3)+1e-8;

% plausibility defined as non-empty intervals that at least have one
% point between 0 and 1

LBSraw       = LBS;
UBSraw       = UBS;

% note that zz variable is not plausibility
not_plausability     =   cond_001+cond_002+cond_01+cond_02+cond_03;

% monotonicity is defined as plausibility plus the lower bound for
% lower lambdas cannot exceed the upper bound for higher lambdas

% % 

cond_1=(LBS(:,1)>=UBS(:,2)+1e-8);
cond_2=(LBS(:,1)>=UBS(:,3)+1e-8) ;
cond_3=(LBS(:,2)>=UBS(:,3)+1e-8);

cond_1_aux = (UBS(:,2)>UBS(:,3))+(LBS(:,1)>=UBS(:,2)+1e-8)==2;
cond_3_aux = (LBS(:,1)>LBS(:,2))+(LBS(:,2)>=UBS(:,3)+1e-8)==2;
cond_2_aux = cond_2==1 & cond_3==0;

not_monotone     =  not_plausability+cond_1+cond_2+cond_3;


LBSrawx       = LBS;
UBSrawx       = UBS;

% next, for those who fail monotonicity, we would like to document the extent of this failure and "bring together"
% their intervals

UBS(cond_3,3)                 = LBSrawx(cond_3,2);
LBS(cond_3_aux,1)             = LBSrawx(cond_3_aux,2);

LBS(cond_1,1)                 = UBSrawx(cond_1,2);
UBS(cond_1_aux,3)             = UBSrawx(cond_1_aux,2);


% LBS(cond_2_aux,2)             = max([ LBS(cond_2_aux,1) LBS(cond_2_aux,2)],[],2);
% UBS(cond_2_aux,3)             = max([ LBS(cond_2_aux,1) LBS(cond_2_aux,2)],[],2);
UBS(cond_2_aux,3)                 = LBSrawx(cond_2_aux,1);

LBS(:,2)=max([LBS(:,1) LBS(:,2)],[],2);
LBS(:,3)=max([LBS(:,2) LBS(:,3)],[],2);
 
UBS(:,2)=min([UBS(:,2) UBS(:,3)],[],2);
UBS(:,1)=min([UBS(:,1) UBS(:,2)],[],2);


Plausibility           =  (not_plausability==0);
Monotonicity           =  (not_monotone==0);

